#!/usr/bin/perl
#!c:/perl/bin/perl.exe
# The above line may need to be changed to reflect the location of
# the perl interpreter on your system.  Use "which perl" on a Unix system
# to make a noble attempt to locate your perl interpreter.  If you are
# installing this on an NT IIS server then you probably do not need to
# modify this line because it will most likely be ignored.  Apache under
# NT generally DOES require the top line to be configured.  We have provided
# two common paths above as examples, only the top line will be used, the
# second line is just there to provide an example.

############################################################################
# MailMan, Standard Edition, version 3.2.19
# Demo Installation
#
# Copyright (c) 1996 - 2002, Endymion Corporation. All rights reserved.
# Endymion Corporation: http://www.endymion.com/
# by Ryan Alyn Porter, 1996 - 2002
# contributions by Stephen M Noa, 2001
#
# This product is not free and is not in the public domain.
# For detailed information on the licensing structure of MailMan, see
# http://www.endymion.com/products/mailman/
#
# Initiated:      9/07/1997 Version 1.1
# Re-awakened:    4/24/1998 Version 2.0 beta
# Released:       7/20/1998 Version 2.0
# Last Modified: 12/10/2002 Version 3.2.19
############################################################################

# If you are having problems with MailMan not working at all, please
# take a look at the MailMan FAQ, stored online at
# http://www.endymion.com/products/mailman/faq.htm.  A version of the FAQ
# should also have been in the distribution that contained this file.

package mailman;

# Enable these while you are working on modifications.  Make absolutely
# certain that 'use strict' is NOT enabled in production installations.
# CGI.pm and 'use strict' are not compatible, if you have 'use strict'
# enabled then your users will not be able to upload files because CGI.pm
# provides uploaded files using a bizarre on-the-fly file handle that will
# cause an error if you have 'use strict' enabled.  We think that this is
# ugly too, but there is no way around it at the moment.
#use strict;
#$^W = 1; # Warnings.

# If you are getting mysterious "Internal Server Error" messages when
# you try to run MailMan, then you might want to un-comment this line
# to get a decent log of the error in a location that you can find.
#BEGIN
#{
#  open(STDERR, 'c:/tmp/mailman_log.txt');
#}

# Version information that might find its way into output.
$mailman::strMailManVersion = 'v3.2.19';
$mailman::strMailManEdition = 'Standard Edition';

# Variable initialization.  Clean and neat and all, but very necessary
# for mod_perl.
InitializeVars();

############################################################################
# This section contains a few variables that you might need to set  in order
# to get MailMan functioning properly.  If your installation is working,
# then you don't need to worry about any of these.
############################################################################

# Outgoing Banner Text
# This is the banner that is appended to the end of any message that
# this MailMan installation sends.  One reason why this is one of the
# first configuration options is because we want to make it very 
# obvious that you can remove or modify this banner.  Endymion places
# no restrictions at all on this banner, so don't worry about leaving
# credit to us in here or anything like that.  Please feel free to 
# change this to whatever you like, or completely remove it.  If this
# value is not defined then it will simply append no banner.
$mailman::strOutgoingBannerText = 
    "\n" .
    "---------------------------------------------\n" .
    "This message was sent using Endymion MailMan.\n" .
    "http://www.endymion.com/products/mailman/\n";

# Incoming Mail Server:
# The way that we originally intended to allow people to 'rig' the server
# names for an installation was through simple template modifications, as
# mentioned in the FAQ.  A lot of people have asked about ways to rig the
# server names in the script itself though, so we added this.  We aim to
# please...  If you want to rig your incoming server name so that it makes
# no difference at all what an incoming form specifies, just un-comment
# this line and specify it.
#$mailman::strIncomingServer = 'mail.endymion.com';

# Outgoing Mail Server:
# Same deal, different server.
#$mailman::strOutgoingServer = 'mail.endymion.com';

# Sendmail Path:
# If you would like your MailMan installation to use a local Sendmail
# invocation when sending outbound mail instead of connecting to an
# SMTP server, then you can un-comment this line and configure this to
# point to the path of your Sendmail command.  Use this if you do not
# have an SMTP server running at all.
# This might also work with some minor modification with other
# command-line agents that support something like Sendmail's "-bs"
# option, which instructs Sendmail to use the SMTP protocol via standard
# input and standard output.  If you have access to an SMTP server then
# you are really probably better off using the wire connection instead
# of this.
#$mailman::strLocalLocationSendmail = '/usr/sbin/sendmail';

# Email Address Settings
# The following few settings pertain to MailMan's need to infer a
# user's email address.  When a user logs in to MailMan, they provide
# a POP3 username, server name, and password.  That's not quite
# enough information though.  If the user ever wants to send mail,
# then MailMan will need to know the user's email address for using
# on the "FROM" line of the outgoing message.  In many cases the
# user's email address can be inferred by concatenating the user's
# POP3 username with the POP3 server name.  For example, the POP3
# user "sales" at the mail server "endymion.com" would result in the
# email address "sales@endymion.com".  This is the default behavior,
# and if it is possible for you to configure your server name simply
# like in this example so that it will result in functional and
# attractive email addresses, then you don't need to do anything to
# any of these options.

# From Domain Trim:
# If you have to specify a machine name for your POP3 server, then
# such as "mail.endymion.com" rather than "endymion.com", then 
# MailMan will guess something dumb like "sales@mail.endymion.com"
# when it needs to guess an email address.  You can use this option
# to have MailMan automatically trim one or more names from the
# left side of a POP3 server's name. The number that you set here
# represents the total number of names to shear off of the left-hand
# side of the machine name.  For instance, if the user's POP3 server
# name is "mail.rex.endymion.com", and you set this value to 0, the
# default, then when the user composes a message MailMan will guess
# "sales@mail.rex.endymion.com" as the 'from' address.  If you set
# this value to 1 then it will guess "sales@rex.endymion.com", if
# you set it to 2 then it will guess "sales@endymion.com", etc.  This
# can be helpful if you have a number of different virtual domains
# and you want the email address to be inferred dynamically, rather
# than by hard-coding it with the "From Domain Name" configuration value.
#$mailman::iFromDomainTrim = 1;

# From Domain Name:
# In some cases, the POP3 server that your users check their mail from
# doesn't have anything to do with the domain name portion of the
# user's email address.  You can use this option to manually set the
# entire domain name portion of a user's email address.
# For instance, consider the hypothetical email address
# "sales@endymion.com", which is served by a mailbox on the server
# "mail5.it.endy-backoffice.com".  When the user "sales" logs into
# the POP3 server "mail5.it.endy-backoffice.com", MailMan will assume
# that the email address is "sales@mail5.it.endy-backoffice.com".
# If you set this variable to "endymion.com", then it will assume that
# this user's email address is "sales@endymion.com" instead.
#$mailman::strFromDomainName = "endymion.com";

# Username is the Email Address
# The above options hopefully helped you to configure the domain name
# portion of your users' email addresses.  In some cases you don't
# want MailMan trying to guess a domain name at all because your users
# log in to the POP3 server with their complete email address.  For
# instance, consider the hypothetical email address "sales@endymion.com"
# that is served by a mailbox called "sales@endymion.com" on the 
# mail server "pop3.endymion.com".  MailMan's default behavior would
# be to infer the email address "sales@endymion.com@pop3.endymion.com",
# which is obviously wrong.  Un-comment the following line to instruct
# MailMan to simply ignore the entire mail server name when inferring
# the user's email address, using only the POP3 username.
#$mailman::bUsernameIsEmailAddress = '1';

# Email Address Mapping File
# This is a last  option if all else fails.  In an increasing number of
# cases, the user's POP3 username has nothing to do with their email
# address at all.  For instance, you might have a user named "endy-sales"
# on your mail server, but that mailbox actually corresponds to the
# email address "sales@endymion.com".  In these cases you either need
# to make a custom code modification to MailMan that will allow your
# user to log in with the name "sales" and have MailMan automatically
# infer or look up the POP3 user name "endy-sales", which is hard and
# may take some time.  The simpler solution is to have your users log
# in using their POP3 username as normal, and then provide a mapping
# file that allows MailMan to look up each user's email address based
# on their POP3 username, like a phone book.  For instance, if you
# provide a flat text file that contains a few lines like this:
# endy-sales   sales@endymion.com
# endy-support support@endymion.com
# (without the '#' marks at the beginning of the lines)
# ...then MailMan will open the file and search for the POP3 user
# name in the left column each time it needs to infer an email
# address.  If an entry is found, then it will use the email address
# listed, if an entry is not found then MailMan will fall back on
# the methods listed above.  To enable this option, simply construct
# a text file and provide the name of the text file here.  The text
# file can be automatically constructed if you like.
#$mailman::strUsernameMappingFileName = "mapfile.txt";

# Outgoing Domain Name:
# When a user specifies a recipient name without full domain qualification
# ("rap" instead of "rap@endymion.com", for example) then the SMTP server
# should provide configuration rules for determining how to deal with this
# mail.  It should not be the responsibility of the mail client to fill in
# a complete address.  We have had many requests for a feature to allow 
# an administrator to specify a default domain name, however, and we aim
# to please.  This configuration variable is the result.  If you want
# MailMan to assume a default domain name when it is given an incomplete
# address, uncomment this line and set it to your domain name.  We strongly
# recommend against this, however, you should be looking into your SMTP
# server's configuration options and not using this feature.
#$mailman::strOutgoingDomainName = 'endymion.com';

# Messages Per Page:
# This value controls the number of messages returned per page in a
# message list.  Adjust it if you like.
$mailman::iMessagesPerPage = 5;

# Redirect Location
# MailMan can redirect users to an alternate web page instead of the login
# page when logging out.  To redirect to an alternate location besides the
# default login page you need to uncomment the line below and set it to the
# URL location of the page you want to use.
#$mailman::strURLRedirectLocation = 'http://www.endymion.com/';

# Local Template Location:
# If you have a web server that sets the current directory to something
# strange, you can set this to an absolute path to make it easier to
# allow MailMan to find the templates.  Just set this variable to an
# absolute path like "C\:\\inetpub\\wwwroot\\mailman\\templates\\"
# or '/usr/home/rap/mailman/' or whatever.  Note the final slash, that's
# important.  If you leave it out then things won't work.  If you need
# to set this value, then un-comment the following line:
#$mailman::strLocalTemplateLocation = "D:/inetpub/wwwroot/Endymion2/products/mailman/demo/";

# Local Script Location:
# If your server is one of the ones that causes problems that require the
# above value to be set, then you might also need to set this value.  In
# most cases your script location and your template location will be 
# identical, but if you move your templates to a different directory than
# your script for whatever reason, then you will need to set this.  If you
# have no idea what I'm talking about, you should probably just leave this.
$mailman::strLocalScriptLocation = $mailman::strLocalTemplateLocation;

# URL Image Location:
# Use this to rig the URLs that will be used to access the images that
# the templates point to.  This value will be prepended to any value in
# the templates of the form ""i_*.gif"" (including the inner quotes).
# If you have customized your templates and your own custom images are
# not showing up in MailMan's output, it is probably because the custom
# images that you are using are not named "i_*.gif".
# To use this variable, set it to the exact value that you want prepended
# to image names in order to make them into URLs that will point to your
# image directory.  For instance, if you bury your images in an "images"
# directory under the directory where MailMan is installed, set this to
# 'images/' (with the slash).  If you put your images in a completely
# different directory, something that is rooted, like '/mailman/images/'
# might be what you are looking for.  In the most extreme cases you can
# do away with relative URLs entirely and provide a complete absolute URL
# like the one below
#$mailman::strURLImageLocation = 'http://www.endymion.com/images/';

# Use Perl 'alarm()' function:
# Set this to true if your Perl interpreter supports "alarm".  As of this
# Writing, NT Perl does not.  If this is not set, MailMan will not be able
# to timeout when a server hangs.  The OSSettings() routine will attempt
# to set this variable, but you can override it here if you want.
# The point of the "alarm" feature as used in MailMan is to allow MailMan
# to detect when a mail server has not responded within a reasonable
# amount of time.  If your server's Perl interpreter does not support
# "alarm", then MailMan will still work, but if a mail server ever does
# not respond then the user will get no feedback to that effect.
#$mailman::bUseAlarm = 1;

# Timeout Duration:
# The aforementioned timeout delay.  Set this to something else to modify
# how long MailMan will sit around waiting for a mail server to respond.
# Only works if $mailman::bUseAlarm is set to something.
$mailman::iTimeoutDurationInSeconds = 180;

# Use Perl 'crypt()' function:
# Some Perl impelentations apparently do not support the crypt() function.
# We have never seen one, and there are plenty of implementations out there
# that you should be able to find a good one, but we try to accomodate
# anyway.  Comment out this line if your Perl implementation is breaking
# on the crypt() function.  Be warned that if you do this your users'
# usernames and passwords will be less obfuscated than they were before,
# which admittedly wasn't much.  This is a good place to repeat the 
# suggestion that MailMan is an excellent candidate for SSL and other
# fancy HTTP security mechanisms.
#$mailman::bUseCrypt = 1;

# Use Hijack Test:
# MailMan performs a test to determine if the current session has been
# hijacked by a different user from a different address.  On a few 
# systems this will not work because of the configuration.  If your
# MailMan installation sits behind a cluster of caching proxy servers
# for load balancing, for instance.  If you want to disable the hijack
# checking functionality, just comment out this line.
#$mailman::bUseHijackTest = 1;

# Kiosk Mode:
# If you are using MailMan in a kiosk environment, it will generally
# be possible for a user to use a combination of "BACK" and "RELOAD" in
# the kiosk web browser to intrude backwards into the mail sessions of
# previous users.  If you set this value then MailMan will operate in
# kiosk mode, which means that when a user logs in, MailMan will create
# a new browser window with that user's session.  If the user logs out
# then that window will close, and the user's history information will
# go with the window so that intrusions with "BACK" and "RELOAD" aren't
# possible.  We recommend against using this feature for installations
# that are not kiosk-based because it relies on Javascript and cookies,
# which does not leave users with older browsers with a way in.  If you
# are in a kiosk environment then you have control over the browser an
# that's not a problem.  We strongly recommend against using the
# Microsoft Internet Explorer for kiosk environments because it does not
# properly respect the "Expires:" and "Cache-control:" HTTP headers, so
# IE will cache user mail to the hard drive whether you want it to or
# not.  Microsoft appears to have no interest in fixing this problem.
# IE 4 SP1 pretty consistently crashed during our tests of the 
# full-screen popup window kiosk mode, too, which is likely not exactly
# the behavior that you are looking for in your kiosk browser.
# The kiosk mode feature primarily activates and deactivates sections
# of outbound templates, so if you have customized your templates before
# you decided to use kiosk mode then it is entirely possible that you
# broke this mode by removing vital Javascript.  Consult the
# out-of-the-box template set for examples of the Javascript snippets
# necessary for this mode.
#$mailman::bKioskMode = 1;

# Date Format
# By default, MailMan does not process dates as date objects, it handles
# them as simple strings.  If you want more control over the formatting
# of your dates, then you can set this date format string and this format
# will be used for the dates on message lists.  The format for this string
# is specified by the documentation for the Date::Manip Perl module, which
# is included in most Unix Perl distributions now.  If you get an error
# when you try to use this, just make sure that you have Date::Manip 
# installed from CPAN, http://www.cpan.org  Note also that date processing
# is dependent on your time zone, so make sure that your 'TZ' environment
# variable is set.  If you get an error about this, then you can always
# explicitly set the time zone by un-commenting the following:
#$ENV{'TZ'} = 'EST';
# Un-comment the following line to instruct MailMan to reformat dates.
#$mailman::strDateFormat = '%m/%d/%Y %H:%M';

# Location Attachments
# When a user selects an attachment from a message for downloading,
# MailMan generates that attachment on-the-fly and sends it through the
# HTTP server to the user's browser.  MailMan includes the necessary
# HTTP header information for the user's browser to determine the
# file name, but many broswers, most notably Microsoft's Internet
# Explorer, either ignore these headers or just don't handle them
# very well.  The result is that when a user downloads an attachment,
# your browser may present the user with a "Save As" box with the
# file name filled in as the name of this script, a string or random
# characters, or any number of other un-graceful things.  We think that
# the best solution to this problem would be for browser makers to
# pay attention to HTTP headers, but until then we provide a mechanism
# for working around the problem.  If you set up a directory that is
# writable by MailMan and readable by your web server, then MailMan
# will write out the attachment file to that directory temporarily,
# and redirect the user's browser to that file.  When the user logs
# in or out MailMan will ensure that the user's files in this
# temporary directory are removed.  A user that exits MailMan without
# logging out and never logs back in could potentially leave stale
# attachment files on the server, so occasional monitoring of the
# temporary directory for stale files would be appropriate.  Also note
# that this mechanism could be considered a privacy problem since a
# user's attachments are deposited temporarily into a world-readable
# directory rather than generated on-the-fly the way MailMan normally
# would do.  We have left the decision up to each individual
# administrator as to whether or not to use this feature.  Most people
# seem to prefer allowing MailMan to generate attachments on-the-fly
# for simplicity, ease of administration, and security/privacy, but
# some people think that the attachment file name thing is a critical
# issue.  The decision is yours.
# IMPORTANT SECURITY ADVISORY:
# Make absolutely certain that the directory that you use for
# attachments does *NOT* allow executable code.  Do NOT use this
# method of attachment handling if you are not absolutely certain
# that executable code is not allowed in that directory.  If your
# temporary directory allows executable code then any attachments
# that end in ".cgi", ".php", ".pl", etc, may be executed by your
# server when they are accessed, rather than simply served.  You do
# *NOT* want this.
# To use this feature, create a directory that is readable by your
# web server and writable by the user that MailMan runs as.  Set
# $mailman::strLocalLocationAttachments to the local path name of 
# this directory, for instance
# $mailman::strLocalLocationAttachments = '/public_html/attachtmp/';
# Then set $mailman::strURLLocationAttachments to the URL location
# of this directory, for instance
# $mailman::strURLLocationAttachments = '/attachtmp/';
# Note the terminal slashes at the end, those are necessary.  Just
# set and uncomment the following lines to use this feature:
#$mailman::strLocalLocationAttachments = 'c:/www/public_html/mailman/tmp/';
#$mailman::strURLLocationAttachments = '/mailman/tmp/';

# Local File Permissions
# Use this if you want to modify the permissions that files and
# directories created by MailMan use.  This will only make much sense
# to Unix and Unix-like operating systems.  If this value is not set,
# nothing will happen.  This should be an octal integer as in the
# example below, not a string.
# This value will only matter if you set
# $mailman::strLocalLocationAttachments and 
# $mailman::strURLLocationAttachments, of course.
$mailman::iLocalFilePermissions = 0600;

# Local Directory Permissions
# Same as above, used for directories created by MailMan.
# This value will only matter if you set
# $mailman::strLocalLocationAttachments and 
# $mailman::strURLLocationAttachments, of course.
$mailman::iLocalDirectoryPermissions = 0700;

# Subject Truncation Length
# This is the maximum length allowed for a subject line in the message
# list pages.  If you set this then subject lines will be truncated at
# this length, for predictable layout.  If you don't set this, then
# subjects will be left untouched.  Subjects will always be left alone
# on the message display page.
$mailman::iSubjectTruncationLength = 30;

# This controls whether MailMan uses 'normal' filenames or MD5 hashes
# of the normal file names in order to pander to the Windows file system.
$mailman::bAlternateFilenames = 0;

# Use this option to tell MailMan to attempt to use APOP when connecting
# to your POP3 server.
#$mailman::bAttemptAPOP = 1;

############################################################################
# You should not have to configure any values after this line.
############################################################################

# The following section of code is CGI manipulation routines
# originally provided as a module called "cgi-lib.pl".  This
# code includes some very minor modifications to that code.
# This is the original copyright notice from that code:
#
# Copyright (c) 1993-1999 Steven E. Brenner  
# Unpublished work.
#
# We have removed the original license notice to avoid confusion
# over MailMan's license.  If you are interested in this excellent
# CGI handling code, then please see:
#     http://cgi-lib.stanford.edu/cgi-lib/

$cgi_lib'version = sprintf("%d.%02d", q$Revision: 2.18 $ =~ /(\d+)\.(\d+)/);

# ReadParse
# Reads in GET or POST data, converts it to unescaped text, and puts
# key/value pairs in %in, using "\0" to separate multiple selections

# Returns >0 if there was input, 0 if there was no input 
# undef indicates some failure.

# Now that cgi scripts can be put in the normal file space, it is useful
# to combine both the form and the script in one place.  If no parameters
# are given (i.e., ReadParse returns FALSE), then a form could be output.

# If a reference to a hash is given, then the data will be stored in that
# hash, but the data from $in and @in will become inaccessable.
# If a variable-glob (e.g., *cgi_input) is the first parameter to ReadParse,
# information is stored there, rather than in $in, @in, and %in.
# Second, third, and fourth parameters fill associative arrays analagous to
# %in with data relevant to file uploads. 

# If no method is given, the script will process both command-line arguments
# of the form: name=value and any text that is in $ENV{'QUERY_STRING'}
# This is intended to aid debugging and may be changed in future releases

sub ReadParse {
  # Disable warnings as this code deliberately uses local and environment
  # variables which are preset to undef (i.e., not explicitly initialized)
  my ($perlwarn);
  $perlwarn = $^W;
  $^W = 0;

  # Parameters affecting cgi-lib behavior
  # User-configurable parameters affecting file upload.
#  $cgi_lib'maxdata    = 131072;    # maximum bytes to accept via POST - 2^17
  $cgi_lib'maxdata    = 5242880;    # five megabytes
  $cgi_lib'writefiles =      0;    # directory to which to write files, or
                                 # 0 if files should not be written
  $cgi_lib'filepre    = "cgi-lib"; # Prefix of file names, in directory above

  # Do not change the following parameters unless you have special reasons
  $cgi_lib'bufsize  =  8192;    # default buffer size when reading multipart
  $cgi_lib'maxbound =   100;    # maximum boundary length to be encounterd
  $cgi_lib'headerout =    0;    # indicates whether the header has been printed

  (*mailman::in) = shift if @_;    # CGI input
  (*mailman::incfn,                # Client's filename (may not be provided)
   *mailman::inct,                 # Client's content-type (may not be provided)
   *mailman::insfn) = @_;          # Server's filename (for spooled files)
  my ($len, $type, $meth, $errflag, $cmdflag, $got, $name);
	
  binmode(STDIN);   # we need these for DOS-based systems
  binmode(STDOUT);  # and they shouldn't hurt anything else 
  binmode(STDERR);
	
  # Get several useful env variables
  $type = $ENV{'CONTENT_TYPE'};
  $len  = $ENV{'CONTENT_LENGTH'};
  $meth = $ENV{'REQUEST_METHOD'};
  
  if ($len > $cgi_lib'maxdata) { #'
      &CgiDie("cgi-lib.pl: Request to receive too much data: $len bytes\n");
  }
  
  if (!defined $meth || $meth eq '' || $meth eq 'GET' || 
      $meth eq 'HEAD' ||
      $type eq 'application/x-www-form-urlencoded') {
    my ($key, $val, $i);
	
    # Read in text
    if (!defined $meth || $meth eq '') {
      $mailman::in = $ENV{'QUERY_STRING'};
      $cmdflag = 1;  # also use command-line options
    } elsif($meth eq 'GET' || $meth eq 'HEAD') {
      $mailman::in = $ENV{'QUERY_STRING'};
    } elsif ($meth eq 'POST') {
        if (($got = read(STDIN, $mailman::in, $len) != $len))
	  {$errflag="Short Read: wanted $len, got $got\n";};
    } else {
      &CgiDie("cgi-lib.pl: Unknown request method: $meth\n");
    }

    @mailman::in = split(/[&;]/,$mailman::in); 
    push(@mailman::in, @ARGV) if $cmdflag; # add command-line parameters

    foreach $i (0 .. $#mailman::in) {
      # Convert plus to space
      $mailman::in[$i] =~ s/\+/ /g;

      # Split into key and value.  
      ($key, $val) = split(/=/,$mailman::in[$i],2); # splits on the first =.

      # Convert %XX from hex numbers to alphanumeric
      $key =~ s/%([A-Fa-f0-9]{2})/pack("c",hex($1))/ge;
      $val =~ s/%([A-Fa-f0-9]{2})/pack("c",hex($1))/ge;

      # Associate key and value
      $mailman::in{$key} .= "\0" if (defined($mailman::in{$key})); # \0 is the multiple separator
      $mailman::in{$key} .= $val;
    }

  } elsif ($ENV{'CONTENT_TYPE'} =~ m/^multipart\/form-data/) {
    # for efficiency, compile multipart code only if needed
    $errflag = !(eval <<'END_MULTIPART');

    my ($buf, $boundary, $head, @heads, $cd, $ct, $fname, $ctype, $blen);
    my ($bpos, $lpos, $left, $amt, $fn, $ser);
    my ($bufsize, $maxbound, $writefiles) = 
      ($cgi_lib'bufsize, $cgi_lib'maxbound, $cgi_lib'writefiles);

    # The following lines exist solely to eliminate spurious warning messages
    $buf = ''; 

    ($boundary) = $type =~ /boundary="([^"]+)"/i; #";   # find boundary
    ($boundary) = $type =~ /boundary=(\S+)/i unless $boundary;
    &CgiDie ("Boundary not provided: probably a bug in your server") 
      unless $boundary;
    $boundary =  "--" . $boundary;
    $blen = length ($boundary);

    if ($ENV{'REQUEST_METHOD'} ne 'POST') {
      &CgiDie("Invalid request method for  multipart/form-data: $meth\n");
    }

    if ($writefiles) {
      my($me);
      stat ($writefiles);
      $writefiles = "/tmp" unless  -d _ && -w _;
      # ($me) = $0 =~ m#([^/]*)$#;
      $writefiles .= "/$cgi_lib'filepre"; 
    }

    # read in the data and split into parts:
    # put headers in @in and data in %in
    # General algorithm:
    #   There are two dividers: the border and the '\r\n\r\n' between
    # header and body.  Iterate between searching for these
    #   Retain a buffer of size(bufsize+maxbound); the latter part is
    # to ensure that dividers don't get lost by wrapping between two bufs
    #   Look for a divider in the current batch.  If not found, then
    # save all of bufsize, move the maxbound extra buffer to the front of
    # the buffer, and read in a new bufsize bytes.  If a divider is found,
    # save everything up to the divider.  Then empty the buffer of everything
    # up to the end of the divider.  Refill buffer to bufsize+maxbound
    #   Note slightly odd organization.  Code before BODY: really goes with
    # code following HEAD:, but is put first to 'pre-fill' buffers.  BODY:
    # is placed before HEAD: because we first need to discard any 'preface,'
    # which would be analagous to a body without a preceeding head.

    $left = $len;
   PART: # find each part of the multi-part while reading data
    while (1) {
      die $@ if $errflag;

      $amt = ($left > $bufsize+$maxbound-length($buf) 
	      ?  $bufsize+$maxbound-length($buf): $left);
      $errflag = (($got = read(STDIN, $buf, $amt, length($buf))) != $amt);
      die "Short Read: wanted $amt, got $got\n" if $errflag;
      $left -= $amt;

      $mailman::in{$name} .= "\0" if defined $mailman::in{$name}; 
      $mailman::in{$name} .= $fn if $fn;

      $name=~/([-\w]+)/;  # This allows $insfn{$name} to be untainted
      if (defined $1) {
        $mailman::insfn{$1} .= "\0" if defined $mailman::insfn{$1}; 
        $mailman::insfn{$1} .= $fn if $fn;
      }

     BODY: 
      while (($bpos = index($buf, $boundary)) == -1) {
        if ($left == 0 && $buf eq '') {
          my $value;
	  foreach $value (values %mailman::insfn) {
            unlink(split("\0",$value));
	  }
	  &CgiDie("cgi-lib.pl: reached end of input while seeking boundary " .
		  "of multipart. Format of CGI input is wrong.\n");
        }
        die $@ if $errflag;
        if ($name) {  # if no $name, then it's the prologue -- discard
          if ($fn) { print FILE substr($buf, 0, $bufsize); }
          else     { $mailman::in{$name} .= substr($buf, 0, $bufsize); }
        }
        $buf = substr($buf, $bufsize);
        $amt = ($left > $bufsize ? $bufsize : $left); #$maxbound==length($buf);
        $errflag = (($got = read(STDIN, $buf, $amt, length($buf))) != $amt);
	die "Short Read: wanted $amt, got $got\n" if $errflag;
        $left -= $amt;
      }
      if (defined $name) {  # if no $name, then it's the prologue -- discard
        if ($fn) { print FILE substr($buf, 0, $bpos-2); }
        else     { $mailman::in {$name} .= substr($buf, 0, $bpos-2); } # kill last \r\n
      }
      close (FILE);
      last PART if substr($buf, $bpos + $blen, 2) eq "--";
      substr($buf, 0, $bpos+$blen+2) = '';
      $amt = ($left > $bufsize+$maxbound-length($buf) 
	      ? $bufsize+$maxbound-length($buf) : $left);
      $errflag = (($got = read(STDIN, $buf, $amt, length($buf))) != $amt);
      die "Short Read: wanted $amt, got $got\n" if $errflag;
      $left -= $amt;


      undef $head;  undef $fn;
     HEAD:
      while (($lpos = index($buf, "\r\n\r\n")) == -1) { 
        if ($left == 0  && $buf eq '') {
	  my $value;
          foreach $value (values %mailman::insfn) {
            unlink(split("\0",$value));
	  }
	  &CgiDie("cgi-lib: reached end of input while seeking end of " .
		  "headers. Format of CGI input is wrong.\n$buf");
        }
        die $@ if $errflag;

        $head .= substr($buf, 0, $bufsize);
        $buf = substr($buf, $bufsize);
        $amt = ($left > $bufsize ? $bufsize : $left); #$maxbound==length($buf);
        $errflag = (($got = read(STDIN, $buf, $amt, length($buf))) != $amt);
        die "Short Read: wanted $amt, got $got\n" if $errflag;
        $left -= $amt;
      }
      $head .= substr($buf, 0, $lpos+2);
      push (@mailman::in, $head);

      @heads = split("\r\n", $head);
      ($cd) = grep (/^\s*Content-Disposition:/i, @heads);
      ($ct) = grep (/^\s*Content-Type:/i, @heads);

      ($name) = $cd =~ /\bname="([^"]+)"/i; #"; 
      ($name) = $cd =~ /\bname=([^\s:;]+)/i unless defined $name;  

      ($fname) = $cd =~ /\bfilename="([^"]*)"/i; #"; # filename can be null-str
      ($fname) = $cd =~ /\bfilename=([^\s:;]+)/i unless defined $fname;
      $mailman::incfn{$name} .= (defined $mailman::in{$name} ? "\0" : "") . 
        (defined $fname ? $fname : "");

      ($ctype) = $ct =~ /^\s*Content-type:\s*"([^"]+)"/i;  #";
      ($ctype) = $ct =~ /^\s*Content-Type:\s*([^\s:;]+)/i unless defined $ctype;
      $mailman::inct{$name} .= (defined $mailman::in{$name} ? "\0" : "") . $ctype;

      if ($writefiles && defined $fname) {
        $ser++;
	$fn = $writefiles . ".$$.$ser";
	open (FILE, ">$fn") || &CgiDie("Couldn't open $fn\n");
        binmode (FILE);  # write files accurately
      }
      substr($buf, 0, $lpos+4) = '';
      undef $fname;
      undef $ctype;
    }

1;
END_MULTIPART
    if ($errflag) {
      my ($errmsg, $value);
      $errmsg = $@ || $errflag;
      foreach $value (values %mailman::insfn) {
        unlink(split("\0",$value));
      }
      &CgiDie($errmsg);
    } else {
      # everything's ok.
    }
  } else {
    &CgiDie("cgi-lib.pl: Unknown Content-type: $ENV{'CONTENT_TYPE'}\n");
  }

  # no-ops to avoid warnings
  $mailman::insfn = $mailman::insfn;
  $mailman::incfn = $mailman::incfn;
  $mailman::inct  = $mailman::inct;

  $^W = $perlwarn;

  return ($errflag ? undef :  scalar(@mailman::in)); 
}


# PrintHeader
# Returns the magic line which tells WWW that we're an HTML document

sub PrintHeader {
  return "Content-type: text/html\n\n";
}


# HtmlTop
# Returns the <head> of a document and the beginning of the body
# with the title and a body <h1> header as specified by the parameter

sub HtmlTop
{
  my ($title) = @_;

  return <<END_OF_TEXT;
<html>
<head>
<title>$title</title>
</head>
<body>
<h1>$title</h1>
END_OF_TEXT
}


# HtmlBot
# Returns the </body>, </html> codes for the bottom of every HTML page

sub HtmlBot
{
  return "</body>\n</html>\n";
}


# SplitParam
# Splits a multi-valued parameter into a list of the constituent parameters

sub SplitParam
{
  my ($param) = @_;
  my (@params) = split ("\0", $param);
  return (wantarray ? @params : $params[0]);
}


# MethGet
# Return true if this cgi call was using the GET request, false otherwise

sub MethGet {
  return (defined $ENV{'REQUEST_METHOD'} && $ENV{'REQUEST_METHOD'} eq "GET");
}


# MethPost
# Return true if this cgi call was using the POST request, false otherwise

sub MethPost {
  return (defined $ENV{'REQUEST_METHOD'} && $ENV{'REQUEST_METHOD'} eq "POST");
}


# MyBaseUrl
# Returns the base URL to the script (i.e., no extra path or query string)
sub MyBaseUrl {
  my ($ret, $perlwarn);
  $perlwarn = $^W; $^W = 0;
  $ret = 'http://' . $ENV{'SERVER_NAME'} .  
         ($ENV{'SERVER_PORT'} != 80 ? ":$ENV{'SERVER_PORT'}" : '') .
         $ENV{'SCRIPT_NAME'};
  $^W = $perlwarn;
  return $ret;
}


# MyFullUrl
# Returns the full URL to the script (i.e., with extra path or query string)
sub MyFullUrl {
  my ($ret, $perlwarn);
  $perlwarn = $^W; $^W = 0;
  $ret = 'http://' . $ENV{'SERVER_NAME'} .  
         ($ENV{'SERVER_PORT'} != 80 ? ":$ENV{'SERVER_PORT'}" : '') .
         $ENV{'SCRIPT_NAME'} . $ENV{'PATH_INFO'} .
         (length ($ENV{'QUERY_STRING'}) ? "?$ENV{'QUERY_STRING'}" : '');
  $^W = $perlwarn;
  return $ret;
}


# MyURL
# Returns the base URL to the script (i.e., no extra path or query string)
# This is obsolete and will be removed in later versions
sub MyURL  {
  return &MyBaseUrl;
}


# CgiError
# Prints out an error message which which containes appropriate headers,
# markup, etcetera.
# Parameters:
#  If no parameters, gives a generic error message
#  Otherwise, the first parameter will be the title and the rest will 
#  be given as different paragraphs of the body

sub CgiError {
  my (@msg) = @_;
  my ($i,$name);

  if (!@msg) {
    $name = &MyFullUrl;
    @msg = ("Error: script $name encountered fatal error\n");
  };

  if (!$cgi_lib'headerout) { #')
    print &PrintHeader;	
    print "<html>\n<head>\n<title>$msg[0]</title>\n</head>\n<body>\n";
  }
  print "<h1>$msg[0]</h1>\n";
  foreach $i (1 .. $#msg) {
    print "<p>$msg[$i]</p>\n";
  }

  $cgi_lib'headerout++;
}

# CgiDie
# Identical to CgiError, but also quits with the passed error message.

sub CgiDie {
  my (@msg) = @_;
  &CgiError (@msg);
  die @msg;
}

# PrintVariables
# Nicely formats variables.  Three calling options:
# A non-null associative array - prints the items in that array
# A type-glob - prints the items in the associated assoc array
# nothing - defaults to use %in
# Typical use: &PrintVariables()

sub PrintVariables {
  local (*in) = @_ if @_ == 1;
  my (%in) = @_ if @_ > 1;
  my ($out, $key, $output);

  $output =  "\n<dl compact>\n";
  foreach $key (sort keys(%in)) {
    foreach (split("\0", $mailman::in{$key})) {
      ($out = $_) =~ s/\n/<br>\n/g;
      $output .=  "<dt><b>$key</b>\n <dd>:<i>$out</i>:<br>\n";
    }
  }
  $output .=  "</dl>\n";

  return $output;
}

# PrintEnv
# Nicely formats all environment variables and returns HTML string
sub PrintEnv {
  &PrintVariables(*ENV);
}

# The following lines exist only to avoid warning messages
$cgi_lib'writefiles =  $cgi_lib'writefiles;
$cgi_lib'bufsize    =  $cgi_lib'bufsize ;
$cgi_lib'maxbound   =  $cgi_lib'maxbound;
$cgi_lib'version    =  $cgi_lib'version;
$cgi_lib'filepre    =  $cgi_lib'filepre;

############################################################################
# MailMan code begins here.
############################################################################

use Socket; use FileHandle; my($mma) = new FileHandle(); &ReadParse; {  my($mmb) = 0;
my($mmc); foreach $mmc (keys(%mailman::in)) { if($mmc =~ /^(.+)\.[xy]$/) {
my($mmd) = $1; if($mmc =~ /^([^\#]+)\#(.*)\.[xy]$/) { $mmd = $1;
$mailman::in{$mmd} = mmnb($2); } else {
$mailman::in{$mmd} = 'MAILMANSPECIALTRUE'; } delete($mailman::in{$mmc}); } else {
if($mmc =~ /^([^\#]+)\#(.*)$/) { $mailman::in{$1} = mmnb($2); } } } }
if($mailman::in{'INTERFACE'}) { my(@mme) = split(/\&/,$mailman::in{'INTERFACE'});
my($mmf) = ''; foreach $mmf (@mme) { if($mmf =~ /^([^\=]+)\=(.*)$/) {
$mailman::in{$1} = mmnb($2); } }
unless($mailman::in{'INTERFACE'} =~ /ALTERNATE_TEMPLATES/) {
$mailman::in{'ALTERNATE_TEMPLATES'} = ''; } } {
@mailman::mmg = split(/\;/,$ENV{'HTTP_COOKIE'}); my($mmh) = '';
foreach $mailman::mmh (@mailman::mmg) { $mailman::mmi = 1;
if($mailman::mmh =~ /MailManAuth\=(\S+)/) { my(@mmj) = split(/\&/,$1);
my($mmk) = ''; foreach $mmk (@mmj) { $mmk =~ /^(.+)\#(.+)$/;
unless($mailman::in{$1}) { $mailman::in{$1} = $2; } } } } }
$mailman::mml = mmnf($mailman::in{'USERNAME'});
$mailman::mml =~ s/^\s*([^\s]+)\s*$/$1/;  if($mailman::mmm) {
$mailman::mml =~ tr/[A-Z]/[a-z]/; } $mailman::mmn = mmne($mailman::mml);
$mailman::mmo = mmnf($mailman::in{'PASSWORD'});
$mailman::mmo =~ s/^\s*([^\s]+)\s*$/$1/; 
$mailman::mmp = mmne($mailman::mmo); unless($mailman::strIncomingServer) {
$mailman::strIncomingServer =  mmnf($mailman::in{'SERVER'});
$mailman::strIncomingServer =~ s/^\s*([^\s]+)\s*$/$1/; 
$mailman::strIncomingServer =~ tr/[A-Z]/[a-z]/;  }
$mailman::mmq = mmne($mailman::strIncomingServer);
unless($mailman::strOutgoingServer) {
$mailman::strOutgoingServer = $mailman::in{'OUTGOING'};
$mailman::strOutgoingServer =~ s/^\s*([^\s]+)\s*$/$1/; 
$mailman::strOutgoingServer =~ tr/[A-Z]/[a-z]/;  } $mailman::mmr = '';
if(defined($mailman::strLocalLocationAttachments) &&
defined($mailman::strURLLocationAttachments)) {
unless($mailman::strLocalLocationAttachments =~ /[\/\\]$/) {
$mailman::strLocalLocationAttachments .= '/'; }
unless($mailman::strURLLocationAttachments =~ /[\/\\]$/) {
$mailman::strURLLocationAttachments .= '/'; } $mailman::mms =
$mailman::strLocalLocationAttachments . mmna($mailman::mml .
'@' . $mailman::strIncomingServer); $mailman::mmt =
$mailman::strURLLocationAttachments . mmna(
mmna($mailman::mml . '@' . $mailman::strIncomingServer));
$mailman::mmu = 1; } $mailman::mmv = mmmz($ENV{SERVER_NAME},42);
$mailman::mmv .= mmmz($ENV{REMOTE_HOST} . $ENV{REMOTE_ADDR},69);
$mailman::mmw = mmne($mailman::mmv); mmmy();
$mailman::mmx = $ENV{SCRIPT_NAME}; unless($mailman::mmx =~ /^\//) {
$mailman::mmx = "/$mailman::mmx"; } $mailman::mmy = $mailman::mmx;
$mailman::mmy =~ s/^(.*[\\\/])[^\\\/]+$/$1/; if($mailman::mmy eq '/') {
$mailman::mmz = ''; } else { $mailman::mmz = "path=$mailman::mmy; "; }
sub mmlg { if($mailman::in{'NOFRAMES'}) { $mailman::mmaa = 1; }
if($mailman::in{'NOCACHE'}) { $mailman::mmab = 1; }
if(defined($mailman::in{'ALTERNATE_TEMPLATES'})) { $mailman::mmac = 
$mailman::in{'ALTERNATE_TEMPLATES'}; $mailman::mmac =~ s/^[\\\/](.+)$/$1/;
$mailman::mmac =~ s/\.\.[\/\\]//; $mailman::mmac =~ s/\x00//g; } }
sub mmlh { my($mmad) = shift; my($mmb) = 0; my($mmc);
foreach $mmc (keys(%mailman::in)) { if($mmc =~ /^$mmad\:(.*)$/) { return $1; } }
return; } mmlg(); mmli(); { my($mmh) = '';
@mailman::mmg = split(/\;/,$ENV{'HTTP_COOKIE'});
foreach $mailman::mmh (@mailman::mmg) { if($mailman::mmh =~ /MailManCmds\=(\S+)/) {
my($mmae) = ''; @mailman::mmaf = split(/\&/,$1); foreach $mmae (@mailman::mmaf) {
$mmae =~ /^(.+)\#(.+)$/; unless($mailman::in{$1}) { $mailman::in{$1} = $2; } } } } }
mmlg(); mmli(); mmll();
sub mmli { my($mmag) = ''; if($mailman::in{'BLANK'}) {
mmmx('t_blank.htm'); } if($mailman::in{'MENU'}) {
mmmx('t_f_menu.htm'); } if($mailman::in{'LOGOUT'}) { if($mailman::mmu) {
mmnn(); } if($mailman::bKioskMode) {
print "Set-cookie: MailManAuth=;$mailman::mmz" .
"expires=Sun, 03-May-1998 16:00:00 GMT\n";
print "Set-cookie: MailManCmds=;$mailman::mmz" .
"expires=Sun, 03-May-1998 16:00:00 GMT\n";
print "Set-cookie: MailManDir=;$mailman::mmz" .
"expires=Sun, 03-May-1998 16:00:00 GMT\n"; $mailman::mml = '';
mmmx('t_closewindow.htm'); } else { if($mailman::strURLRedirectLocation) {
print "Set-cookie: MailManAuth=;$mailman::mmz" .
"expires=Sun, 03-May-1998 16:00:00 GMT\n";
print "Set-cookie: MailManCmds=;$mailman::mmz" .
"expires=Sun, 03-May-1998 16:00:00 GMT\n";
print "Set-cookie: MailManDir=;$mailman::mmz" .
"expires=Sun, 03-May-1998 16:00:00 GMT\n";
print "Location: $mailman::strURLRedirectLocation\n\n"; } else { mmll(); }
} } if($mailman::in{'START'}) { mmll(); } if($mailman::in{'LOGIN'}) {
my($mmah) = ''; if($mmah = mmln()) { if(defined($mmah)) {
$mmah =~ s/\-ERR//; } $mailman::bKioskMode = 0; $mailman::mmai{'GREETING'} = 
qq|<div align="center"><b>Log In Error: | . qq|</b><i>$mmah</i></div>|;
mmmx('t_login.htm',\%mailman::mmai); }

if(mmmc() <= 0){ mmlz(); exit(0); }
 if($mailman::mmu) {
mmnn(); } if($mailman::mmaa) { mmlx(); } else {

print eval(mmmb($mailman::mhaa[0]));
 } }
if($mailman::bUseHijackTest &&  $mailman::in{'CHECKSUM'} && 
$mailman::in{'CHECKSUM'} ne '') {
if(mmnf($mailman::in{'CHECKSUM'}) ne $mailman::mmv) { mmlj(
qq|Your MailMan session was initiated from a different | .
qq|network address than your current location.  For | .
qq|security reasons, MailMan will not continue. | .
qq|You must <a href="MailMan(ME)?LOGOUT=TRUE" | .
qq|target="_top">log in again</a> from this location | . qq|to continue.|); } }
if($mailman::in{'RELOAD'}) { if($mailman::mmaa) { mmlx(); } else {
mmmx('t_f_frameset.htm'); } } if($mmag = mmlh('LIST')) {
mmlx($mmag); } if($mailman::in{'LIST'}) { mmlx(); }
my($mmaj) = $mailman::in{'BACKGROUND'}; if($mmaj) { if($mailman::mmaa) {
print "Location: $mmaj\n\n"; exit(0); } else { mmlw($mmaj); } }
if($mmaj = $mailman::in{'BACKGROUNDFRAME'}) {
mmmx('t_backgroundframe.htm'); } if($mmag = mmlh('SHOW')) {
my($mmak) = -1; if($mmag =~ /^(.+)mimepart\:(.+)$/) { $mmak = $1;
$mailman::mmal = $2; $mailman::mmal =~ s/%(..)/pack("c",hex($1))/ge; }
elsif($mmag =~ /^(.+)cid\:(.+)$/) { $mmak = $1; $mailman::mmam = $2;
$mailman::mmam = mmnb($2); } else { $mmak = $mmag; }
$mmak = mmnb($mmak); $mmak = mmlu($mmak); mmmk($mmak,0); }
if($mmag = mmlh('SOURCE')) { my($mmak) = mmnb($mmag);
$mmak = mmlu($mmak); mmml($mmak); }
if($mmag = mmlh('PREV')) { my($mmak) = mmnb($mmag);
$mmak = mmlu($mmak); mmmk($mmak,-1); }
if($mmag = mmlh('NEXT')) { my($mmak) = mmnb($mmag);
$mmak = mmlu($mmak); mmmk($mmak,1); }
if($mmag = mmlh('DELETE')) { my($mmah) = mmln(); if($mmah) {
mmlj($mmah); } my($mmak) = mmnb($mmag); $mmak = mmlu($mmak);
mmmn($mmak); mmlm($mma,"QUIT"); close $mma; $mailman::mman = 0;
if($mailman::mmaa) { mmlx(); } else { mmmx('t_f_frameset.htm');
} } if($mailman::in{'DELETEMARKED'}) { my($mmah) = ''; if($mmah = mmln())
{ mmlj($mmah); } my($mmb) = 0; my($mmc); foreach $mmc (keys(%mailman::in)) {
if($mmc =~ /^MARK\:(.*)$/) { my($mmak) = mmnb($1);
$mmak = mmlu($mmak); mmmn($mmak); } } mmlm($mma,"QUIT");
close $mma; $mailman::mman = 0; if($mailman::mmaa) { mmlx(); } else {
mmmx('t_f_frameset.htm'); } } if($mmag = mmlh('MOVE')) {
my($mmao) =  mmna($mailman::in{'FOLDERTRANSFERLIST'});
if($mmao eq 'MAILMANSPECIALSELECT' || $mmao eq '') { mmlx(); }
my($mmah) = ''; if($mmah = mmln()) { mmlj($mmah); }
my($mmak) = mmnb($mmag); $mmak = mmlu($mmak);
if(CopyMessageToFolder($mmak,$mmao)) { RemoveMessageFromFolder($mmak,'MOVED'); }
mmlm($mma,"QUIT"); close $mma; $mailman::mman = 0; if($mailman::mmaa) {
mmlx(); } else { mmmx('t_f_frameset.htm'); } }
if($mailman::in{'MOVEMARKED'}) { my($mmao) =
mmna($mailman::in{'FOLDERTRANSFERLIST'});
if($mmao eq 'MAILMANSPECIALSELECT' || $mmao eq '') { mmlx(); }
my($mmah) = ''; if($mmah = mmln()) { mmlj($mmah); } my($mmb) = 0;
my($mmc); foreach $mmc (keys(%mailman::in)) { if($mmc =~ /^MARK\:(.*)$/) {
my($mmak) = mmnb($1); $mmak = mmlu($mmak);
if(CopyMessageToFolder($mmak,$mmao)) { RemoveMessageFromFolder($mmak,'MOVED'); } } }
mmlm($mma,"QUIT"); close $mma; $mailman::mman = 0; if($mailman::mmaa) {
mmlx(); } else { mmmx('t_f_frameset.htm'); } }
if($mailman::in{'NEW'}) { $mailman::in{'ATTACH'} = 0;
my $mmap = ($mailman::in{'MAILTO'}) ?
mmnb($mailman::in{'MAILTO'}) : undef;
mmmo('NEW', 0, 0, $mmap); } if($mailman::in{'USEATTACH'}) {
$mailman::in{'ATTACH'} = 1; mmmp(''); }
if($mmag = mmlh('REPLY')) { my($mmak) = mmnb($mmag);
$mmak = mmlu($mmak); mmmo($mmak,0,0); }
if($mmag = mmlh('REPLYALL')) { my($mmak) = mmnb($mmag);
$mmak = mmlu($mmak); mmmo($mmak,1,0); }
if($mmag = mmlh('FORWARD')) { my($mmak) = mmnb($mmag);
$mmak = mmlu($mmak); mmmo($mmak,0,1); } if($mailman::in{'SEND'}) {
mmmr(); } if($mailman::in{'HELP'}) { mmmx('t_help.htm'); } }
sub mmlj { my($mmaq,$mmar) =  @_; my($mmas) = ''; if($mmaq eq "ALRM") {
if($mailman::bUseAlarm){ alarm(0); } $mmaq = $mailman::mmat;
mmlm($mma,"QUIT"); close $mma; } if($mailman::mmaa) {
$mmas = 't_nf_error.htm'; } else { $mmas = 't_f_error.htm'; } my(%mmai);
$mmai{'ERROR'} = $mmaq; mmmx($mmas,\%mmai); unless($mmar) { exit(1); } }
sub mmlk { my($mmau) =  @_; my($mmas) = ''; print CGI->multipart_start();
if($mailman::mmaa) { $mmas = 't_nf_status.htm'; } else { $mmas = 't_f_status.htm'; }
my(%mmai); $mmai{'STATUS'} = $mmau; mmmx($mmas,\%mmai);
print CGI->multipart_end(); } sub mmll {
print "Set-cookie: MailManAuth=;$mailman::mmz" .
"expires=Sun, 03-May-1998 16:00:00 GMT\n";
print "Set-cookie: MailManCmds=;$mailman::mmz" .
"expires=Sun, 03-May-1998 16:00:00 GMT\n";
print "Set-cookie: MailManDir=;$mailman::mmz" .
"expires=Sun, 03-May-1998 16:00:00 GMT\n";
print "Expires: Sun, 03 May 1998 16:00:00 GMT\n"; $mailman::mml = '';
$mailman::mmav = ''; if($mailman::bKioskMode) { my($mmaw) = '';
($mailman::mmai{'GREETING'},$mmaw) = mmmw('t_login.htm',
('GREETING','KIOSKMODESCRIPT')); $mailman::mmai{'HTMLCOMMENTBEGIN'} = '<!-- ';
$mailman::mmai{'HTMLCOMMENTEND'} = ' -->'; $mailman::mmai{'KIOSKMODESCRIPT'} =
mmmt($mmaw,\%mailman::mmai);
$mailman::mmai{'HTMLCOMMENTBEGIN'} = ''; $mailman::mmai{'HTMLCOMMENTEND'} = ''; }
else { $mailman::mmai{'GREETING'} =
mmmv('t_login.htm','GREETING'); }

print eval(mmmb($mailman::mhaa[1]));
 } sub mmlm {
my($mmaz) = "\015\012"; my($mmba, $mmbb) = @_; my($mmbc) = length($mmbb . $mmaz);
syswrite($mmba,$mmbb . $mmaz,$mmbc); } sub mmln {
if($mailman::mman){ return; } my($mmbd); unless(defined($mailman::mml) &&
$mailman::mml ne '') { return("No username provided, cannot proceed."); }
unless(defined($mailman::mmo) && $mailman::mmo ne '') {
return("No password provided, cannot proceed."); }
unless(defined($mailman::strIncomingServer) && $mailman::strIncomingServer ne '')
{ return("No server provided, cannot proceed."); }
retrylogin: if($mailman::bUseAlarm) { $mailman::mmat =
"Connection to server timed out."; $SIG{'ALRM'} = \&mmlj;
alarm($mailman::iTimeoutDurationInSeconds); } my($mmbe) = 0;
$mmbe = getprotobyname('tcp'); socket($mma,PF_INET,SOCK_STREAM,$mmbe);
my($mmbf) = 0; $mmbf = gethostbyname($mailman::strIncomingServer); unless($mmbf) {
return("Could not find an IP address for the host " .
"\"$mailman::strIncomingServer\"."); } my($mmbg) = '';
$mmbg = sockaddr_in(110, $mmbf); unless(connect($mma, $mmbg)) {
return("Could not connect to server " .
"\"$mailman::strIncomingServer\", \"$!\""); } select($mma); $|=1; select(STDOUT);
binmode($mma); $mailman::mmat = "The server connected, but will not respond.";
if($mailman::bUseAlarm){ alarm($mailman::iTimeoutDurationInSeconds); }
my $mmbh = <$mma>; unless($mmbh =~ /^\+OK/) {
return("The server does not respond appropriately."); }
if(defined($mailman::bAttemptAPOP) && $mmbh =~ /^\+OK[^\<]*(\<[^\>]+\>)/) {
my $mmbi = $1; my $mmbj = $mailman::mmo; my $mmbk = undef; my $mmbl = q!
use Digest::MD5 qw(md5_hex); $mmbk = md5_hex($mmbi . $mmbj);!; eval($mmbl);
if(defined($mmbk)) { $mailman::mmat = "The server timed out during login.";
if($mailman::bUseAlarm) { alarm($mailman::iTimeoutDurationInSeconds); }
mmlm($mma, "APOP $mailman::mml $mmbk"); my($mmbm) = ''; $mmbm = <$mma>;
unless($mmbm =~ /^\+OK/) { return("APOP authentication failure: \"$mmbm\""); }
goto authenticated; } } $mailman::mmat = "The server timed out during login.";
if($mailman::bUseAlarm){ alarm($mailman::iTimeoutDurationInSeconds); }
mmlm($mma, "USER $mailman::mml"); my($mmbm) = ''; $mmbm = <$mma>;
unless($mmbm =~ /^\+OK/) { return($mmbm); } mmlm($mma,"PASS $mailman::mmo");
$mmbm = <$mma>; unless($mmbm =~ /^\+OK/) { if((($mmbm =~ /another session/i) ||
($mmbm =~ /another POP3 session/i) || ($mmbm =~ /mailbox in use/i) ||
($mmbm =~ /unable to lock/i) || ($mmbm =~ /mailbox already locked/i) ||
($mmbm =~ /mailbox is currently locked/i) || ($mmbm =~ /mailbox busy/i)) &&
$mmbd < 12) { mmlm($mma,"QUIT"); close $mma; $mmbd++; sleep(5);
goto retrylogin; } else { return "Access denied: $mmbm"; } return($mmbm); }
if($mailman::bUseAlarm) { alarm(0); } authenticated: mmlm($mma,'STAT');
$mmbm = <$mma>; $mmbm =~ /^\+OK\s+(\d+)\s+/i; $mailman::mmbn = $1;
if($mailman::mmbn == 0) { $mailman::mman = 1; return; } mmlm($mma,"LIST");
$mmbm = <$mma>; unless($mmbm =~ /^\+OK/) { return($mmbm); } $mailman::mmbn = 0;
while(<$mma> =~ /(\d+) (\d+)/) { $mailman::mmbo[$1] = $2; $mailman::mmbn++; }
$mailman::mman = 1; return; } sub mmlo { my($mmbp) =  @_;
$mailman::mmat = "The server timed out fetching a header.";
if($mailman::bUseAlarm){ alarm($mailman::iTimeoutDurationInSeconds); }
mmlm($mma,"TOP $mmbp 0"); my($mmbm) = ''; $mmbm = <$mma>;
unless($mmbm =~ /^\+OK/) { mmlm($mma,"RETR $mmbp"); my($mmbm) = '';
$mmbm = <$mma>; unless($mmbm =~ /^\+OK/) { mmlj($mmbm); } }
mmlp($mma); $mailman::mmbq = $mmbp . 'H' . $mailman::mmbr;
$mailman::mmbs = $mmbp; } sub mmlp { my($mmba) = shift;
$mailman::mmbt = ''; $mailman::mmbu = ''; $mailman::mmbv = ''; $mailman::mmbw = '';
$mailman::mmbx = '0'; $mailman::mmby = ''; $mailman::mmbz = '';
$mailman::mmbr = ''; $mailman::mmca = 0; $mailman::mmcb = 0; my($mmcc) = 0;
my($mmcd) = 0; my($mmce) = 0; my($mmcf) = 0; my($mmcg) = 1; my($mmch) = '';
my($mmci) = -1; while(defined($_ = <$mmba>)) { if(/^[\r\n]+$/){ $mmcc = 1; }
if(/^\.[\r\n]*$/){ last; } if(/^Content-type\:\s+([^\;\s]+)[\;\s]/i) {
my($mmcj) = $1; if( ($mmcj !~ /multipart\/alternative/i) && ($mmcj !~ /text\//i)) {
$mailman::mmcb = 1; } } if(/^begin \d\d\d (\S+)\s*$/i) { $mailman::mmcb = 1; }
if(/^X\-Mailer\: Crescent Internet ToolPak ActiveX Mail Control/i) {
$mailman::mmcb = 1; } unless($mmcc) { $mmcg = 1;
if(/^To\:\s*(.+)$/i || ((/^\s(.+)$/) && $mmcd)) { $mailman::mmbt .= $1;
$mailman::mmbt =~ s/^(.*)[\r\n]+$/$1/;
$mailman::mmbt = mmlq($mailman::mmbt); $mmch .= $_; $mmcd = 1; $mmcf = 0;
$mmce = 0; $mmcg = 0; } if(/^CC\:\s*(.+)$/i || ((/^\s(.+)$/) && $mmcf)) {
$mailman::mmbu .= $1; $mailman::mmbu =~ s/^(.*)[\r\n]+$/$1/;
$mailman::mmbu = mmlq($mailman::mmbu); $mmch .= $_; $mmcd = 0; $mmcf = 1;
$mmce = 0; $mmcg = 0; } if(/^From\:\s*(.+)$/i || ((/^\s(.+)$/) && $mmce)) {
$mailman::mmbv .= $1; $mailman::mmbv =~ s/^(.*)[\r\n]+$/$1/;
$mailman::mmbv = mmlq($mailman::mmbv); $mmch .= $_; $mmcd = 0; $mmcf = 0;
$mmce = 1; $mmcg = 0; } if(/^Date\:\s*(.+)$/i) { $mailman::mmbw = $1;
$mailman::mmbw =~ s/^(.*)[\r\n]+$/$1/; $mmch .= $_; } if(/^Subject\:\s*(.+)$/i) {
$mailman::mmby = $1; $mailman::mmby =~ s/^(.*)[\r\n]+$/$1/;
$mailman::mmby = mmlq($mailman::mmby); $mmch .= $_; }
if(/^Reply-To\:\s*(.+)$/i) { $mailman::mmbz = $1;
$mailman::mmbz =~ s/^(.*)[\r\n]+$/$1/; $mmch .= $_; } if(/^Message-ID\:\s*(.+)$/i) {
$mailman::mmbr = $1; $mailman::mmbr =~ s/^(.*)[\r\n]+$/$1/; }        if($mmcg) {
$mmcd = 0; $mmcf = 0; $mmce = 0; } } if(/^MIME-Version\:\s*1\.0/i) { if(!$mmcc) {
$mailman::mmca = 1; } } } if($mailman::mmbr eq "") { $mailman::mmbr = $mmch;
while(length($mailman::mmbr)>20) {
$mailman::mmbr = (substr($mailman::mmbr,0,20) ^  substr($mailman::mmbr,20)); }
$mailman::mmbr = pack("u*",$mailman::mmbr); }
$mailman::mmbr =~ s/(\W)/sprintf("%%%x", ord($1))/eg;
unless($mailman::mmbt){ $mailman::mmbt = "Unknown";}
unless($mailman::mmbv){ $mailman::mmbv = "Unknown";}
unless($mailman::mmbw){ $mailman::mmbw = "Unknown";}
unless($mailman::mmby){ $mailman::mmby = "Unspecified";}
unless($mailman::mmbq){ $mailman::mmbq = "0";}
$mailman::mmck = mmls($mailman::mmbt);
$mailman::mmcl = mmls($mailman::mmbv);
$mailman::mmcm = mmls($mailman::mmbu);
$mailman::mmcn = mmls($mailman::mmby);
$mailman::mmco = mmls($mailman::mmbw); } sub mmlq { my $mmcp = shift;
$mmcp =~ s/\=\?(iso-8859-\d|us-ascii)\?q\?([^\?]+)\?\=/
mmmf(mmme($2))/xeig; $mmcp =~
s/\=\?(iso-8859-\d|us-ascii)\?b\?([^\?]+)\?\=/
mmmg(mmme($2))/xeig; return $mmcp; } sub mmlr {
my($mmak) = @_; $mmak =~ /^(\d+)H(.+)$/; my($mmcq) = $1; my($mmcr) = $2;
if($1 eq '' || $2 eq '') { mmlj('The message ID string "' . $mmak . 
'" is poorly formed.'); } $mmcr =~ s/%(..)/pack("c",hex($1))/ge; $mailman::mmat =
"The server timed out during message listing.";
if($mailman::bUseAlarm){ alarm($mailman::iTimeoutDurationInSeconds); }
mmlm($mma,"LIST"); my($mmbm) = ''; $mmbm = <$mma>; unless($mmbm =~ /^\+OK/)
{ mmlj($mmbm); } $mailman::mmcs = 0; while(<$mma> =~ /(\d+) (\d+)/) {
$mailman::mmbo[$1] = $2; $mailman::mmcs++; } my($mmb) = $mmcq; my($mmct) = 0;
while($mmb>0) { mmlo($mmb);
$mailman::mmbr =~ s/%(..)/pack("c",hex($1))/ge; if($mailman::mmbr eq  $mmcr) {
$mmct = 1; last; } $mmb--; } if(!$mmct) {
mmlj('Could not find the specified message.'); } return ($mmb); } sub mmls
{ my($mmcu) = @_; $mmcu =~ s/\&/\&amp\;/g; $mmcu =~ s/\</\&lt\;/g;
$mmcu =~ s/\>/\&gt\;/g; $mmcu =~ s/\%mmcv/\</g; $mmcu =~ s/\%mmcw/\>/g;
my($mmcx) = '(http://|https://|ftp://)' .
q%(?:&(?![gl]t;)|[^\s\(\)\|<>,"'\&])+% . q%[^\.?!;,"'\|\[\]\(\)\s<>\&]%;
my($mmcy) = "\<a target=\"_top\" href\=\"$mailman::mmx?BACKGROUND="; $mmcu =~
s/($mmcx)/$mmcy.mmna($1)."\"\>$1\<\/a\>"/eig; if($mailman::mmaa) {
$mmcu =~ s/(href\=\"[^\"]*)(BACKGROUND\=)/${1}NOFRAMES\=TRUE&$2/g; } return $mmcu;
} sub mmlt { my($mmcz) = shift; $mmcz =~ s/([\w\W])/sprintf("%02x",ord($1))/eg;
return $mmcz; } sub mmlu { my($mmcz) = shift;
$mmcz =~ s/([a-fA-F0-9]{2})/pack("C",hex($1))/eg; return $mmcz; }
sub mmlv { my $mmda = shift; $mmda =~
s/([0-9a-z\.\-\+\&_]+\@[0-9a-z\.\-]+)/\<a
href\=\"$mailman::mmx?NEW=TRUE&MAILTO=$1\" target=\"_top\"\>$1\<\/a\>/ig;
return $mmda; } sub mmlw { my($mmdb) = shift;
$mailman::mmai{'URL'} = $mmdb;
mmmx('t_backgroundframeset.htm',\%mailman::mmai); }
sub mmlx {  my($mmdc) = @_; unless(defined($mmdc)) { $mmdc = 0; }
my($mmdd, $mmde) = (0, 0); my($mmas) = ''; if($mailman::mmaa) {
if($mailman::mmav eq 'SENT') { my($mmdf) = 't_nf_messagelistsent.htm';
if(defined($mailman::mmac)) { $mmdf = $mailman::mmac . $mmdf; } if(-e
"${mailman::strLocalTemplateLocation}$mmdf") { $mmas = 't_nf_messagelistsent.htm';
} else { $mmas = 't_nf_messagelist.htm'; } } else { $mmas = 't_nf_messagelist.htm'; } }
else { if($mailman::mmav eq 'SENT') { my($mmdf) = 't_f_messagelistsent.htm';
if(defined($mailman::mmac)) { $mmdf = $mailman::mmac . $mmdf; } if(-e
"${mailman::strLocalTemplateLocation}$mmdf") { $mmas = 't_f_messagelistsent.htm'; }
else { $mmas = 't_f_messagelist.htm'; } } else { $mmas = 't_f_messagelist.htm'; } }
my($mmdg, $mmdh, $mmdi, $mmdj) = ('','','',''); ($mmdg, $mmdh, $mmdj, $mmdi) =
mmmw($mmas, ('MESSAGE_EVEN', 'MESSAGE_ODD',
'ATTACHMENT_IMAGE', 'UNREAD_IMAGE')); my($mmah) = '';
if($mmah = mmln()) { mmlj($mmah); }
$mailman::mmai{'USERNAME'} = $mailman::mml;
$mailman::mmai{'USERNAMEHIDDEN'} = $mailman::mmn;
$mailman::mmai{'SERVERHIDDEN'} = $mailman::mmq;
$mailman::mmai{'PASSWORDHIDDEN'} = $mailman::mmp;
$mailman::mmai{'CHECKSUM'} = $mailman::mmw;
$mailman::mmai{'NUM'} = $mailman::mmbn; if(defined($mailman::strFromDomainName)) {
$mailman::mmai{'SERVER'} = mmnp($mailman::strFromDomainName); } else {
$mailman::mmai{'SERVER'} = mmnp($mailman::strIncomingServer); }
if($mailman::mmbn > 0) { $mailman::mmat =
"The server timed out during message listing.";
if($mailman::bUseAlarm){ alarm($mailman::iTimeoutDurationInSeconds); }
mmlm($mma,"LIST"); my($mmbm) = ''; $mmbm = <$mma>; unless($mmbm =~ /^\+OK/)
{ mmlj($mmbm); } $mailman::mmbn = 0; while(<$mma> =~ /(\d+) (\d+)/) {
$mailman::mmbo[$1] = $2; $mailman::mmbn++; } }    if($mailman::mmbn > 0) {
if($mmdc == 0) { $mmdc = $mailman::mmbn; } my($mmdk); if($mailman::mmbn > 1) {
my($mmdl) = 0; for($mmdl=$mailman::mmbn; $mmdl>0;
$mmdl-=$mailman::iMessagesPerPage) { my($mmdm) = $mmdl;
my($mmdn) = $mmdl-$mailman::iMessagesPerPage+1; my($mmdo) = ''; if($mmdn<1) {
$mmdn = 1; } if($mmdc <= $mmdm && $mmdc >= $mmdn) { $mmdk = 1; $mmdd = $mmdm;
$mmde = $mmdn; } else { $mmdk = 0; } if($mmdm == $mmdn) { $mmdo = "$mmdm"; } else {
$mmdo = "$mmdm-$mmdn"; } if($mailman::mmaa) { if($mmdk) {
$mailman::mmai{'PAGELINKS'} .=  "<b>[$mmdo]</b> "; } else {
$mailman::mmai{'PAGELINKS'} .=  qq|<input type="submit" class="pagebutton" | .
qq|name="LIST:$mmdm" | . qq|value="$mmdo"> |; } } else { if($mmdk) {
$mailman::mmai{'PAGELINKS'} .=  "<b>[$mmdo]</b> "; } else {
$mailman::mmai{'PAGELINKS'} .= qq|<a href="$mailman::mmx?LIST:$mmdm=TRUE">| .
qq|[$mmdo]</a> |; } } } } else { $mailman::mmai{'PAGELINKS'} = ''; $mmdd = 1; $mmde = 1; }
} if($mailman::mmbn > 0) { $mailman::mmai{'MESSAGELIST'} = ''; my($mmdl) = 0;
for($mmdl=$mmdd;$mmdl>=$mmde;$mmdl--) { mmlo($mmdl);
$mailman::mmai{'TO'} = $mailman::mmck; $mailman::mmai{'MESSAGENUM'} = $mmdl;
$mailman::mmai{'DATE'} = $mailman::mmco;
$mailman::mmai{'SUBJECT'} = $mailman::mmcn;
if(defined($mailman::iSubjectTruncationLength)) { if(length($mailman::mmby) >
$mailman::iSubjectTruncationLength) { $mailman::mmai{'SUBJECT'} = mmls(
substr($mailman::mmby, 0, $mailman::iSubjectTruncationLength - 3) . '...'); } }
$mailman::mmai{'SIZE'} = int($mailman::mmbo[$mmdl] / 1024);
if($mailman::mmai{'SIZE'} == 0) { $mailman::mmai{'SIZE'} = "1"; }
$mailman::mmai{'ID'} = mmlt($mailman::mmbq);
$mailman::mmai{'FROM'} = $mailman::mmcl; if($mailman::mmbv =~ /^([^\<]+)\s?\</) {
$mailman::mmai{'FROM'} = mmls(mmlq($1)); }
if($mailman::mmbv =~ /\"([^\"]+)\"/) { $mailman::mmai{'FROM'} =
mmls(mmlq($1)); } if(defined($mailman::strDateFormat)) { my $mmdp = q!
use Date::Manip; Date_Init();!; eval($mmdp); $mmdp = q!
my $mmdq = ParseDate($mailman::mmbw); if($mmdq) { $mailman::mmai{'DATE'} =
mmls(UnixDate($mmdq, $mailman::strDateFormat)); }!; eval($mmdp); }
if($mailman::mmcb) { $mailman::mmai{'ATTACHMENT_IMAGE'} = $mmdj; } else {
$mailman::mmai{'ATTACHMENT_IMAGE'} = ''; } $mailman::mmai{'OPENIMAGE'} = $mmdi;
my($mmdr); if($mmdl%2==0) { $mmdr = mmmt($mmdg,\%mailman::mmai); }
else { $mmdr = mmmt($mmdh,\%mailman::mmai); }
$mailman::mmai{'MESSAGELIST'} .= $mmdr; } } mmlm($mma,"QUIT"); close $mma;
if($mailman::mmai{'MESSAGELIST'} eq '') { $mailman::mmai{'MESSAGELIST'} =
mmmv($mmas,'NOMESSAGES'); }
$mailman::mmai{'FROM'} = mmnl();

print eval(mmmb($mailman::mhaa[2]));
 }
sub mmly { my($mmak,$mmed) =  @_; my($mmee) = 0; my($mmbb) = '';
my($mmah) = ''; if($mmah = mmln()) { mmlj($mmah); }
my($mmbp) = mmlr($mmak); $mmbp += $mmed; if($mmbp > $mailman::mmcs) {
if($mailman::mmaa) { mmlx(); } else { mmlj("No next message."); } }
if($mmbp < 1) { if($mailman::mmaa) { mmlx(); } else {
mmlj("No previous message."); } } if($mmed != 0) { mmlo($mmbp); }
$mailman::mmat = "The server timed out retrieving a message.";
if($mailman::bUseAlarm){ alarm($mailman::iTimeoutDurationInSeconds); }
my($mmef) = $mmbp; mmlm($mma,"RETR $mmef"); my($mmbm) = ''; $mmbm = <$mma>;
unless($mmbm =~ /^\+OK/) { mmlj($mmbm); } $mmee = 0; $mmbb = '';
while(defined($mmbb = <$mma>)) { if($mmbb =~ /^\.\r$/){ last; }
$mailman::mmeg[$mmee++] = $mmbb; } mmlm($mma,"QUIT"); close $mma; }

sub mmlz { print "Content-type: text/html\n\n"; print unpack('u',
"M5&AI<R!D96UO(&EN<W1A;&QA=&EO;B!O9B!-86EL36%N(&AA<R!E>'!I<F5D!+@``"); exit(0); }

sub mmma { my($mmeh,$mmei) = @_; my($mmdr) = ''; my($mmej) = '';
my($mmek) = ''; my($mmel) = 0; my($mmem) = 0; my($mmen) = 0; my($mmeo) = '';
my($mmep) = ''; my($mmeq) = localtime(time); $mmeq = mmne($mmeq);
my(@mmer,@mmes,@mmet, $mmeu,@mmev,@mmew); my($mmex); my(@mmey,@mmez,$mmfa,@mmfb); {
my($mmcc)=0; $mmeu=0; my($mmcp)= ''; headerline: foreach $_ (@$mmeh) { $mmcp .= $_;
if(/^[\r\n]+$/){ last headerline; } }        $mmcp =~ s/[\r\n]/ /g;
$mmcp =~ s/boundary=(\S+)\s/boundary=$1;/g; if(($mmcp =~
/Content-type\:\s+multipart\/mixed\s?;.*boundary\=\"?([^\"\;]+)\"?\;?\s/si) ||
($mmcp =~
/Content-type\:\s+multipart\/signed\s?;.*boundary\=\"?([^\"\;]+)\"?\;?\s/si) ||
($mmcp =~
/Content-type\:\s+multipart\/report\s?;.*boundary\=\"?([^\"\;]+)\"?\;?\s/si)) {
$mmex = 'multipart/mixed'; $mmej = $1; $mmep = mmnc($mmej);
$mailman::mmfc = 1; } elsif(($mmcp =~
/Content-type\:\s+multipart\/mixed\s?;.*boundary\=\"?([^\"\;]+)\"?\;?\s/si) ||
($mmcp =~
/Content-type\:\s+multipart\/signed\s?;.*boundary\=\"?([^\"\;]+)\"?\;?\s/si) ||
($mmcp =~
/Content-type\:\s+multipart\/report\s?;.*boundary\=\"?([^\"\;]+)\"?\;?\s/si)) {
$mmex = 'multipart/mixed'; $mmej = $1; $mmep = mmnc($mmej);
$mailman::mmfc = 1; } elsif($mmcp =~
/Content-type\:\s+multipart\/alternative\s?;.*boundary\=\"?([^\"\;]+)\"?\;?\s/si)
{ $mmex = 'multipart/alternative'; $mmej = $1; $mmej =~ s/^\s*(\S*)\s*$/$1/;
$mmep = mmnc($mmej); } elsif($mmcp =~
/Content-type\:\s+multipart\/related\s?;.*boundary\=\"?([^\"\;]+)\"?\;?\s/si) {
$mmex = 'multipart/related'; $mmej = $1; $mmep = mmnc($mmej); }
elsif($mmcp =~ /Content-type\:\s+([^\;]+);.*name\=\"?([^\"\;]+)\"?\;?\s/si) {
$mmex = $mmes[0] = $1; $mmek = $mmev[0] = $2; $mmel = 0; $mmer[0][$mmem++] = 
"Content-type: $1; name=\"$2\"\n"; } elsif($mmcp =~ /Content-type\:\s+([^\;]+)/si)
{ $mmex = $mmes[0] = $1; $mmek = $mmev[0] = 'messagebody'; $mmel = 0;
$mmer[0][$mmem++] =  "Content-type: $1\n"; } if($mmcp =~
/Content-transfer-encoding\:\s+(\S+)\s/si) { $mmer[0][$mmem++] = 
"Content-transfer-encoding: $1\n"; } $mmer[0][$mmem++] = "\n"; $mmcc=0; $mmeu=0;
messageline: foreach $_ (@$mmeh) { if($mmcc) { if(/^\-\-$mmep\-\-/) {
last messageline; } if(/^\-\-$mmep/) { $mmeu++; $mmem=0; $mmen=0; $mmet[$mmeu] =
$mmej . 'P' . $mmeu; next messageline; } $mmer[$mmeu][$mmem++] = $_; if(/^[\r\n]+$/)
{ if(!$mmen) { $mmen = 1; unless(defined($mmev[$mmeu])) { $mmev[$mmeu] = 'Untitled'; } } }
if(!$mmen) { if(/name\=\"?([^\"]+)\"?/i) { my($mmfd) = $1; $mmev[$mmeu] =
mmlq($mmfd); } if(/^Content-type\:\s+([^\;]+)\;?/i) { $mmeo = $1;
$mmes[$mmeu] = $mmeo; } if(/^Content-ID\:\s+([^\;]+)\;?/i) { my($mmfe) = $1;
$mmfe =~ s/\<([^\>]+)\>/$1/g; $mmfe =~ s/\s*(\S+)\s*/$1/g; $mmew[$mmeu] = $mmfe; } }
} if(/^[\r\n\s]+$/) { $mmcc = 1; } } } if($mailman::mmal eq '0') {
mmmd($mmer[0]); } my($mmff)=1; if($mailman::mmal ne '') {
for(;$mmff<=$mmeu;$mmff++) { if($mmet[$mmff] eq $mailman::mmal) {
mmmd($mmer[$mmff]); } } } elsif($mailman::mmam ne '') {
for(;$mmff<=$mmeu;$mmff++) { if($mmew[$mmff] eq $mailman::mmam) {
mmmd($mmer[$mmff]); } } } if($mailman::mmca) { if($mmex =~ /text\/plain/i) {
$mmdr .= mmmi($mmeh, $mmei); return $mmdr; }
elsif($mmex =~ /text\/html/i) { $mmdr .= mmmj($mmeh, $mmei);
return $mmdr; } elsif($mmex !~ /multipart\/mixed/i &&
$mmex !~ /multipart\/alternative/i && $mmex !~ /multipart\/related/i) { if($mmei) {
$mmdr .= mmmi($mmeh, $mmei); } else {
my $mmfg = mmlt($mailman::mmbq); if(($mmes[0] =~ /message\/rfc822/i) ||
$mmes[0] =~ /message\/delivery\-status/i) { $mmdr .=
qq|<table border="1"><tr><td>\n| . qq|<pre>\n|; my($mmbb) = '';
my($mmfh) = $mmer[0]; foreach $mmbb (@$mmfh) { $mmdr .= mmls($mmbb); } $mmdr .=
qq|</pre>\n| . qq|</td></tr></table>\n|; } elsif($mailman::mmaa) { $mmdr .= 
qq|<p>\n| . qq|<input type="hidden" name="UNIQUE" value="$mmeq">\n| .
qq|<input type="submit" | . qq|name="SHOW:${mmfg}mimepart:0" | .
qq|value="$mmek">\n| . qq|</p>\n|; } else { if($mmek =~ /\.(jpg)|(gif)|(png)\s*$/i) {
$mmdr .= qq|<p>\n| . qq|<center>\n| .
qq|<table cellspacing=0 cellpadding=0 border=0>\n| .
qq|<tr><td align="center"><b>Attachment 1:</b>\n| .
qq|<a href="$mailman::mmx?SHOW:${mmfg}mimepart:0=TRUE">\n| .
qq|$mmek</a></td></tr>\n| . qq|<tr><td>\n| .
qq|<a href="$mailman::mmx?SHOW:${mmfg}mimepart:0=TRUE">\n| .
qq|<img src="$mailman::mmx?SHOW:${mmfg}mimepart:0=TRUE"></a>\n| .
qq|</td></tr>\n| . qq|</table></center></p>\n|; } else { $mmdr .=
qq|<p><b>Attachment 1:</b>\n| .
qq|<a href="$mailman::mmx?SHOW:${mmfg}mimepart:0=TRUE">\n| . qq|$mmek</a></p>\n|;
} } } return $mmdr; } my($mmff)=1; if($mmex =~ /multipart\/mixed/i) {
if($mmes[1] =~ /multipart\/alternative/i || $mmes[1] =~ /multipart\/mixed/i) {
$mmdr .= mmma($mmer[1], $mmei); } elsif($mmes[1] =~ /text\/plain/i) {
$mmdr .= mmmi($mmer[1], $mmei); }
elsif($mmes[1] =~ /text\/html/i) { if($mmei) {
$mmdr .= mmmi($mmer[1], $mmei); } else {
$mmdr .= mmmj($mmer[1]); } } else { $mmff = 0; } }
elsif($mmex =~ /multipart\/alternative/i) { my($mmfi) = 0;
for(;$mmfi<=$mmeu;$mmfi++) { if($mmes[$mmfi] =~ /text\/html/i && !$mmei) { $mmdr .= 
mmmj($mmer[$mmfi]); return $mmdr; } } $mmfi = 0;
for(;$mmfi<=$mmeu;$mmfi++) { if($mmes[$mmfi] =~ /text\/plain/i) { $mmdr .=
mmmi($mmer[$mmfi], $mmei); return $mmdr; } }
$mmdr .= mmmi($mmeh, $mmei); return($mmdr); }
elsif($mmex =~ /multipart\/related/i) { $mmdr .= mmma($mmer[1],$mmei); }
else { $mmdr .= mmmi($mmeh, $mmei); return($mmdr); } if($mmei) {
return($mmdr); } if($mmex eq 'multipart/mixed') { for(;$mmff<$mmeu;$mmff++) {
my($mmfj) = $mmet[$mmff+1]; $mmfj =  mmna($mmfj);
my $mmfg = mmlt($mailman::mmbq); if(!defined($mmer[$mmff+1])) { ; }
elsif(($mmes[$mmff+1] =~ /message\/rfc822/i) || ($mmes[$mmff+1] =~
/message\/delivery\-status/i) || ($mmes[$mmff+1] eq '')) { $mmdr .=
qq|<table border="1"><tr><td>\n| . qq|<pre>\n|; my($mmbb) = '';
my($mmfh) = $mmer[$mmff+1]; foreach $mmbb (@$mmfh) { $mmdr .= $mmbb; } $mmdr .=
qq|</pre>\n| . qq|</td></tr></table><br><br>\n|; } elsif($mailman::mmaa) { $mmdr .= 
qq|<p>\n| . qq|<input type="hidden" name="UNIQUE" value="$mmeq">\n| .
qq|<input type="submit" | . qq|name="SHOW:${mmfg}mimepart:$mmfj" | .
qq|value="$mmev[$mmff+1]">\n| . qq|</p>\n|; } else { if($mmev[$mmff+1] =~
/\.(jpg)|(gif)|(png)\s*$/i) { $mmdr .= qq|<p>\n| . qq|<center>\n| .
qq|<table cellspacing=0 cellpadding=0 border=0>\n| .
qq|<tr><td align="center"><b>Attachment #$mmff:</b>\n| .
qq|<a href="$mailman::mmx?SHOW:${mmfg}mimepart:$mmfj=TRUE">\n| .
qq|$mmev[$mmff+1]</a></td></tr>\n| . qq|<tr><td align="center">\n| .
qq|<a href="$mailman::mmx?SHOW:${mmfg}mimepart:$mmfj=TRUE">\n| .
qq|<img src="$mailman::mmx?SHOW:${mmfg}mimepart:$mmfj=TRUE"></a>\n| .
qq|</td></tr>\n| . qq|</table></center></p>\n|; } else { $mmdr .=
qq|<p><b>Attachment #$mmff:</b>\n| .
qq|<a href="$mailman::mmx?SHOW:${mmfg}mimepart:$mmfj=TRUE">\n| .
qq|$mmev[$mmff+1]</a></p>\n|; } } } } } else { $mmfa=0;
plaintextline: foreach $_ (@$mmeh) { if(/^begin \d\d\d (\S+)\s*$/i) { $mmfa++;
$mmem=0; $mmfb[$mmfa] = $1; $mmez[$mmfa] = $1 . 'P' . $mmfa; next plaintextline; }
elsif($mmfa>0 && /^end\s*$/i) { $mmfa++; $mmem=0; $mmey[$mmfa] .= "Fake Header\n\n";
next plaintextline; } $mmey[$mmfa][$mmem++] = $_; } if($mailman::mmal ne '') {
my($mmfk) = 0; for(;$mmfk<=$mmfa;$mmfk++) { if($mmez[$mmfk] eq $mailman::mmal) {
if($mmfb[$mmfk] eq '') { $mmdr .= mmmi($mmey[$mmfk], $mmei);
return $mmdr; } else { mmmh($mmey[$mmfk],$mmfb[$mmfk]); } } } } else {
my($mmfk) = 0; for(;$mmfk<=$mmfa;$mmfk++) {
if(!defined($mmfb[$mmfk]) || $mmfb[$mmfk] eq '') {
$mmdr .= mmmi($mmey[$mmfk], $mmei); } elsif(!$mmei) {
my($mmfl) = $mmez[$mmfk]; $mmfl =  mmna($mmfl);
my $mmfg = mmlt($mailman::mmbq); if($mailman::mmaa) { $mmdr .=
'<form method="post" action="' . $mailman::mmx .
'"><input type="submit" name="' . 'SHOW:' . $mmfg . 'mimepart:' . $mmfl . 
"\" value=\"$mmfb[$mmfk]\"></form><br>\n"; } else { if($mmfb[$mmfk] =~
/\.(jpg)|(gif)|(png)\s*$/i) { $mmdr .= qq|<p>\n| . qq|<center>\n| .
qq|<table cellspacing=0 cellpadding=0 border=0>\n| .
qq|<tr><td align="center"><b>Attachment #$mmfk:</b>\n| .
qq|<a href="$mailman::mmx?SHOW:${mmfg}mimepart:$mmfl=TRUE">\n| .
qq|$mmfb[$mmfk]</a></td></tr>\n| . qq|<tr><td align="center">\n| .
qq|<a href="$mailman::mmx?SHOW:${mmfg}mimepart:$mmfl=TRUE">\n| .
qq|<img src="$mailman::mmx?SHOW:${mmfg}mimepart:$mmfl=TRUE"></a>\n| .
qq|</td></tr>\n| . qq|</table></center></p>\n|; } else { $mmdr .=
qq|<p><b>Attachment #$mmfk:</b>\n| .
qq|<a href="$mailman::mmx?SHOW:${mmfg}mimepart:$mmfl=TRUE">\n| .
qq|$mmfb[$mmfk]</a></p>\n|; } } } } } if($mmes[0] =~ /text\/html/i) {
$mmdr = mmmj($mmeh); } return($mmdr); } return($mmdr); }

 sub mmmb {
my($mmfm) = shift; $mmfm =~ s/([a-fA-F0-9]{2})/pack("C",hex($1))/eg; return $mmfm;
} sub mmmc { my($mmds) = ''; {
my($mmdt,$mmdu,$mmdv,$mmdw,$mmdx,$mmdy,$mmdz,$mmea,$mmeb) = gmtime(time);
my(@mmec) = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep',
'Oct','Nov','Dec'); $mmds = "$mmdw $mmec[$mmdx] " . ($mmdy + 1900) . 
" $mmdv:$mmdu:$mmdt +0000"; } return ( ( 503492405 - mmnh($mmds) ) /
86400  ); }
 sub mmmd { my($mmfn) = @_; my($mmfo,$mmfp) = (0, 0);
my($mmfq) = 0; my($mmen) = 0; my($mmbb) = ''; my($mmfr) = ''; my($mmcp) = '';
my($mmda) = ''; my($mmfs) = 'Untitled'; foreach $mmbb (@$mmfn) {
if($mmbb =~ /^Content-transfer-encoding\: base64/i) { $mmfo = 1; }
elsif($mmbb =~ /^Content-transfer-encoding\: quoted-printable/i) { $mmfp = 1; }
elsif($mmbb =~ /^Content-transfer-encoding\: x-uuencode/i) { $mmfq = 1; } else {
if($mmen && $mmfo) { $mmfr .= $mmbb; } elsif($mmen && $mmfp) { $mmfr .= $mmbb; }
elsif($mmen) { $mmfr .= $mmbb; } else { $mmcp .= $mmbb; } } if($mmbb =~ /^[\r\n]+$/) {
$mmen = 1; $mmcp =~ s/[\r\n]+[ \t]+(\S)/ $1/gs; if($mmfq) { my $mmft; do {
$mmft = shift(@$mmfn); } while($mmft !~ /^begin \d\d\d (\S+)\s*$/i); $mmfs = $1;
mmmh($mmfn, $mmfs); exit(0); } } if(!$mmen &&
$mmbb =~ /name\=\"?([^\"\;]+)\"?\;?\s/si) { $mmfs = $1; } } if($mmfo) {
$mmda = mmmg($mmfr); } elsif($mmfp) { $mmda = mmmf($mmfr); }
else { $mmda = $mmfr; } print "Expires: Sun, 03 May 1998 16:00:00 GMT\n"; 
my($mmfu,$mmfv,$mmfw) = mmnd(); if($mmfu !~ /MSIE/i) {
print "Cache-control: no-cache\n"; } unless($mailman::mmu) { print $mmcp;
print $mmda; exit(0); } else { unless(-d $mailman::mms) {
unless(mkdir($mailman::mms,0755)) {
mmlj("Could not create temporary directory for " .
"storing the attachment file.  Make sure that " . "the directory " .
"\"$mailman::mms\" exists " . "and is writable by the web user. The " .
"specific error was \"$!\"."); } if(defined($mailman::iLocalDirectoryPermissions))
{ mmng($mailman::mms, $mailman::iLocalDirectoryPermissions); } }
my $mmfx = $mmfs; if($mmfs =~ /^(.+)(\.[^\.]+)$/) { my $mmfy = $1; my $mmfz = $2;
$mmfs = mmna(mmna($mmfy)) . $mmfz; } else {
$mmfs = mmna(mmna($mmfs)); } my($mmga) = new FileHandle();
my($mmgb) = $mailman::mms . '/' . $mmfs; unless(open($mmga,">$mmgb")) {
mmlj("Could not create temporary attachment file in \"" .
$mmgb ."\".  Make sure that the  " .
"directory is writable by the web user. The " . "specific error was \"$!\"."); }
binmode($mmga); print {$mmga} $mmda; close($mmga); if ($mmfx =~ /^(.+)(\.[^\.]+)$/)
{ my($mmgc) = $mailman::mmt . '/' .
mmna(mmna(mmna($1))) . $2;
print "Location: $mmgc\n\n"; } else { my($mmgc) = $mailman::mmt . '/' . $mmfs;
print "Location: $mmgc\n\n"; } exit(0); } } sub mmme { my $mmfr = shift;
$mmfr =~ tr/\_/\ /; return $mmfr; } sub mmmf { my($mmfr) = @_;
my($mmgd); $mmfr =~ s/\s+(\r?\n)/$1/g; $mmfr =~ s/=\r?\n//g; $mmgd = $mmfr;
$mmgd =~ s/=([\da-fA-F]{2})/pack("C", hex($1))/ge; return($mmgd); }
sub mmmg { my($mmfr) = @_; my($mmgd);
$mmfr =~ tr|A-Za-z0-9+=/||cd;             if(length($mmfr)%4) { return($mmfr); }
$mmfr =~ s/=+$//; $mmfr =~ tr|A-Za-z0-9+/| -_|; while($mmfr =~ /(.{1,60})/gs) {
my($mmge) = chr(32+length($1)*3/4); $mmgd .= unpack("u",$mmge . $1 ); }
return($mmgd); } sub mmmh { my($mmgf,$mmgg) = @_;
print "Expires: Sun, 03 May 1998 16:00:00 GMT\n";  my($mmfu,$mmfv,$mmfw) =
mmnd(); if($mmfu !~ /MSIE/i) { print "Cache-control: no-cache\n";  }
unless($mailman::mmu) { print
qq|Content-Type: application\/octet-stream; name="$mmgg"\n\n|; my($mmdr) = '';
my($mmbb) = ''; foreach $mmbb (@$mmgf) { $mmdr .= unpack('u',$mmbb); } print $mmdr;
exit(0); } else { unless(-d $mailman::mms) { unless(mkdir($mailman::mms,0755)) {
mmlj("Could not create temporary directory for " .
"storing the attachment file.  Make sure that " . "the directory " .
"\"$mailman::mms\" exists " . "and is writable by the web user. The " .
"specific error was \"$!\"."); } if(defined($mailman::iLocalDirectoryPermissions))
{ mmng($mailman::mms, $mailman::iLocalDirectoryPermissions); } }
my($mmga) = new FileHandle(); my($mmgb) = $mailman::mms . '/' . $mmgg;
unless(open($mmga,">$mmgb")) {
mmlj("Could not temporary attachment file in \"" .
$mmgb ."\".  Make sure that the  " .
"directory is writable by the web user. The " . "specific error was \"$!\"."); }
binmode($mmga); my($mmbb) = ''; foreach $mmbb (@$mmgf) {
print {$mmga} unpack('u',$mmbb); } close($mmga); my($mmgc) =
$mailman::mmt . '/' . $mmgg; print "Location: $mmgc\n\n"; exit(0); } }
sub mmmi { my($mmeh,$mmei) = @_; my($mmfo,$mmfp); my($mmdr) = '';
my($mmcc) = 0; my($mmfr) = ''; if(!$mmei) { $mmdr = "<pre>\n"; } $mmcc=0;
foreach $_ (@$mmeh) { if(!$mmcc) { if(/^Content-transfer-encoding\: base64/i) {
$mmfo = 1; } elsif(/^Content-transfer-encoding\: quoted-printable/i) { $mmfp = 1; } }
if($mmcc) { my($mmgh) = ''; if($mmfp || $mmfo) { $mmfr = $_; if($mmfo) {
$mmgh = mmmg($mmfr); } elsif($mmfp) { $mmgh = mmmf($mmfr); }
} else { $mmgh = $_; } my($mmgi) = length($mmgh); my($mmgj) = ''; if($mmei) {
$mmgj = $mmgh; } else { $mmgj = mmlv(mmls($mmgh)); }
my($mmgk) = 90 + (length($mmgj) - $mmgi); $mmgj =~ s/([^\n]{1,$mmgk})\s/$1\n/g;
$mmgj =~ s/\015//g; if($mmei) { $mmgj = '> ' . $mmgj; } $mmdr .= $mmgj ; }
if(/^[\r\n]+$/){ $mmcc = 1; } } if($mmfo) { $mmdr .= mmmg($mmfr); }
elsif($mmfp) { $mmdr .= mmmf($mmfr); } if(!$mmei) {
$mmdr .= "</pre>\n"; } return $mmdr; } sub mmmj { my($mmeh) = @_;
my($mmfo,$mmfp); my($mmfr) = ''; my($mmdr) = ''; my($mmcc) = 0; foreach $_ (@$mmeh) {
if(!$mmcc) { if(/^Content-transfer-encoding\: base64/i) { $mmfo = 1; }
elsif(/^Content-transfer-encoding\: quoted-printable/i) { $mmfp = 1; } } if($mmcc) { 
if($mmfp || $mmfo) { $mmfr .= $_; } else { my($mmgj) = $_; $mmgj =~ s/\r//g;
$mmdr .= $mmgj; } } if(/^[\r\n\s]+$/){ $mmcc = 1; } } if($mmfo) {
$mmdr .= mmmg($mmfr); } elsif($mmfp) {
$mmdr .= mmmf($mmfr); }
$mmdr =~ s/\<\/?(html|head|body|title)[^\>]*\>//sig;
my $mmfg = mmlt($mailman::mmbq); $mmdr =~
s/(src\s*\=\s*\")cid\:([^\"]+)(\")/$1 . "${mailman::mmx}?SHOW:${mmfg}cid:" .
mmna($2) . '=TRUE' . $3/egi; return $mmdr; } sub mmmk {
my($mmak,$mmed) =  @_; mmly($mmak,$mmed); my($mmas) = ''; if($mailman::mmaa)
{ $mmas = 't_nf_message.htm'; } else { $mmas = 't_f_message.htm'; }
$mailman::mmai{'USERNAME'} = $mailman::mml;
$mailman::mmai{'USERNAMEHIDDEN'} = $mailman::mmn;
$mailman::mmai{'SERVER'} = $mailman::strIncomingServer;
$mailman::mmai{'SERVERHIDDEN'} = $mailman::mmq;
$mailman::mmai{'PASSWORDHIDDEN'} = $mailman::mmp;
$mailman::mmai{'CHECKSUM'} = $mailman::mmw;
$mailman::mmai{'NUM'} = $mailman::mmcs; $mailman::mmai{'TO'} = $mailman::mmck;
$mailman::mmai{'FROM'} = $mailman::mmcl; $mailman::mmai{'DATE'} = $mailman::mmbw;
$mailman::mmai{'SUBJECT'} = $mailman::mmcn;
$mailman::mmai{'MESSAGENUM'} = $mailman::mmbs;
$mailman::mmai{'MESSAGE'} = mmma(\@mailman::mmeg);
$mailman::mmai{'ID'} = mmlt($mailman::mmbq);
$mailman::mmai{'CC'} = $mailman::mmcm; $mailman::mmgl = 
mmmv($mmas,'CCLINE'); if($mailman::mmbu eq '') {
$mailman::mmgl = ''; } else { $mailman::mmgl =
mmmt($mailman::mmgl,\%mailman::mmai); }
$mailman::mmai{'CCLINE'} = $mailman::mmgl; mmmx($mmas,\%mailman::mmai);
} sub mmml { my($mmak,$mmed) =  @_; mmly($mmak,$mmed);
my($mmas) = ''; if($mailman::mmaa) { $mmas = 't_nf_message.htm'; } else {
$mmas = 't_f_message.htm'; } $mailman::mmai{'USERNAME'} = $mailman::mml;
$mailman::mmai{'USERNAMEHIDDEN'} = $mailman::mmn;
$mailman::mmai{'SERVER'} = $mailman::strIncomingServer;
$mailman::mmai{'SERVERHIDDEN'} = $mailman::mmq;
$mailman::mmai{'PASSWORDHIDDEN'} = $mailman::mmp;
$mailman::mmai{'CHECKSUM'} = $mailman::mmw;
$mailman::mmai{'NUM'} = $mailman::mmcs;
$mailman::mmai{'MESSAGENUM'} = $mailman::mmbs;
$mailman::mmai{'TO'} = $mailman::mmck; $mailman::mmai{'FROM'} = $mailman::mmcl;
$mailman::mmai{'DATE'} = $mailman::mmbw;
$mailman::mmai{'SUBJECT'} = $mailman::mmcn;
$mailman::mmai{'ID'} = mmlt($mailman::mmbq);
$mailman::mmai{'CC'} = $mailman::mmcm; $mailman::mmgl = 
mmmv($mmas,'CCLINE'); if($mailman::mmbu eq '') {
$mailman::mmgl = ''; } else {
$mailman::mmgl = mmmt($mailman::mmgl,\%mailman::mmai); }
$mailman::mmai{'CCLINE'} = $mailman::mmgl; $mailman::mmai{'MESSAGE'} = "<pre>\n";
my($mmbb) = ''; foreach $mmbb (@mailman::mmeg) { $mmbb =~ s/\015//g;
$mmbb =~ s/\&/\&amp\;/g; $mmbb =~ s/\</\&lt\;/g; $mmbb =~ s/\>/\&gt\;/g;
$mailman::mmai{'MESSAGE'} .= $mmbb; } $mailman::mmai{'MESSAGE'} .= "</pre>\n";
mmmx($mmas,\%mailman::mmai); } sub mmmm { my($mmak) =  @_;
$mailman::mmbn = mmlr($mmak); mmlm($mma,"DELE $mailman::mmbn");
my($mmbm) = ''; $mmbm = <$mma>; unless($mmbm =~ /^\+OK/) { mmlj($mmbm); } }
sub mmmn { my($mmak) =  @_; mmmm($mmak); }
sub mmmo { my($mmak,$mmgm,$mmgn, $mmbt) =  @_; my($mmdr) = '';
my($mmgo) = ''; my($mmgp) = ''; my($mmgq) = '';
$mailman::mmai{'ATTACH'} = $mailman::in{'ATTACH'}; my($mmas) = '';
$mmas = 't_messageform.htm'; if($mmak ne 'NEW') { mmly($mmak,0);
$mmgo = $mailman::mmbt; $mmgp = $mailman::mmbv; $mmgq = $mailman::mmby;
if($mailman::mmbz) { $mailman::mmbt = $mailman::mmbz; } else {
$mailman::mmbt = $mailman::mmbv; } if($mmgm) { $mailman::mmbt .= ", $mmgo";
if($mailman::mmbu){ $mailman::mmbt .= ", $mailman::mmbu"; } } if($mmgn) {
unless($mailman::mmby =~ /^fwd\:/i) { $mailman::mmby = "Fwd: $mailman::mmby"; }
$mailman::mmbt = ""; } else { unless($mailman::mmby =~ /^re\:/i) {
$mailman::mmby = "Re: $mailman::mmby"; } } $mailman::mmbu = ''; }
$mailman::mmbt =~ s/\"/&quot;/g; $mailman::mmby =~ s/\"/&quot;/g;
if($mmak ne 'NEW') { $mailman::mmfc = 0; $mmdr = mmma(\@mailman::mmeg,1);
if($mmgn) { my($mmgr) = mmmv($mmas, 'FORWARDHEADER');
$mailman::mmai{'ORIGINALTO'} = $mmgo; $mailman::mmai{'ORIGINALFROM'} = $mmgp;
$mailman::mmai{'ORIGINALSUBJECT'} = $mmgq;
$mailman::mmai{'ORIGINALDATE'} = $mailman::mmbw;
$mmdr = mmmt($mmgr, \%mailman::mmai) . $mmdr; if($mailman::mmfc) {
$mailman::mmgs = $mmak; $mailman::mmai{'ERROR'} = 
'The original message attachment(s) ' . 'will be included in this message.'; } } }
$mailman::mmai{'USERNAME'} = $mailman::mml;
$mailman::mmai{'USERNAMEHIDDEN'} = $mailman::mmn;
$mailman::mmai{'SERVER'} = $mailman::strIncomingServer;
$mailman::mmai{'SERVERHIDDEN'} = $mailman::mmq;
$mailman::mmai{'PASSWORDHIDDEN'} = $mailman::mmp;
$mailman::mmai{'CHECKSUM'} = $mailman::mmw;
$mailman::mmai{'NUM'} = $mailman::mmbn; $mailman::mmai{'MESSAGE'} = $mmdr;
$mailman::mmai{'TO'} = $mailman::mmbt; $mailman::mmai{'CC'} = $mailman::mmbu;
$mailman::mmai{'SUBJECT'} = $mailman::mmby;
$mailman::mmai{'FROM'} = mmnl(); my($mmfu,$mmfv,$mmfw) =
mmnd(); my($mmgt) = 0; if(($mmfu =~ /MSIE/i    && $mmfv >= 4) ||
($mmfu =~ /Mozilla/i && $mmfv >= 2) || ($mmfu =~ /Opera/i   && $mmfv >= 5)) {
if(!$mmgn) { if($mailman::in{'ATTACH'}) { $mailman::mmai{'UPLOAD'} =
mmmv($mmas, 'UPLOAD'); $mmgt = 1; } else {
$mailman::mmai{'UPLOAD'} = mmmv($mmas, 'BENIGNUPLOAD'); } }
else { $mailman::mmai{'UPLOAD'} = ''; } } else { $mailman::mmai{'UPLOAD'} = ''; }
if($mmgt) { $mailman::mmai{'MULTIPARTTAG'} =
mmmv($mmas,'MULTIPARTTAG');
$mailman::mmai{'ENCTYPE'} = "multipart/form-data"; } else {
$mailman::mmai{'ENCTYPE'} = "application/x-www-form-urlencoded"; }
mmmx($mmas,\%mailman::mmai); } sub mmmp { my($mmah,$mmgu) = @_;
my($mmgn) = 0; $mailman::mmai{'ATTACH'} = $mailman::in{'ATTACH'}; my($mmas) = '';
$mmas = 't_messageform.htm'; $mailman::mmai{'USERNAME'} = $mailman::mml;
$mailman::mmai{'USERNAMEHIDDEN'} = $mailman::mmn;
$mailman::mmai{'SERVER'} = $mailman::strIncomingServer;
$mailman::mmai{'SERVERHIDDEN'} = $mailman::mmq;
$mailman::mmai{'PASSWORDHIDDEN'} = $mailman::mmp;
$mailman::mmai{'CHECKSUM'} = $mailman::mmw;
$mailman::mmai{'NUM'} = $mailman::in{'NUM'};
$mailman::mmai{'TO'} = $mailman::in{'TO'};
$mailman::mmai{'CC'} = $mailman::in{'CC'};
$mailman::mmai{'FROM'} = $mailman::in{'FROM'};
$mailman::mmai{'SUBJECT'} = $mailman::in{'SUBJECT'};
$mailman::mmai{'OUTGOING'} = $mailman::strOutgoingServer;
$mailman::mmai{'ERROR'} = $mmah; unless(defined($mmgu) && length($$mmgu)) {
$mailman::mmai{'MESSAGE'} = $mailman::in{'TEXT'}; } else {
$mailman::mmai{'MESSAGE'} = $$mmgu; }
if(defined($mailman::in{'FORWARDATTACHMENTS'})) { $mailman::mmgs =
mmnb($mailman::in{'FORWARDATTACHMENTS'}); $mmgn = 1; }
my($mmfu,$mmfv,$mmfw) = mmnd(); my($mmgt) = 0;
if(($mmfu =~ /MSIE/i    && $mmfv >= 4) || ($mmfu =~ /Mozilla/i && $mmfv >= 2) ||
($mmfu =~ /Opera/i   && $mmfv >= 5)) { if(!$mmgn) { if($mailman::in{'ATTACH'}) {
$mailman::mmai{'UPLOAD'} = mmmv($mmas, 'UPLOAD'); $mmgt = 1; }
else { $mailman::mmai{'UPLOAD'} = mmmv($mmas, 'BENIGNUPLOAD');
} } else { $mailman::mmai{'UPLOAD'} = ''; } } else { $mailman::mmai{'UPLOAD'} = ''; }
if($mmgt) { $mailman::mmai{'MULTIPARTTAG'} =
mmmv($mmas,'MULTIPARTTAG');
$mailman::mmai{'ENCTYPE'} = "multipart/form-data"; } else {
$mailman::mmai{'ENCTYPE'} = "application/x-www-form-urlencoded"; }
mmmx($mmas,\%mailman::mmai); } sub mmmq { my($mmaz) = "\015\012";
my($mmba, $mmbb) = @_; if($mailman::mmgv) { print $mailman::mmgw $mmbb . $mmaz; }
else { my($mmbc) = length($mmbb . $mmaz); syswrite($mmba,$mmbb . $mmaz,$mmbc); } }
sub mmmr { my($mmaz) = "\015\012"; my($mmdr) = ''; my($mmej) = '';
my($mmgx) = ''; my($mmbt) = ''; my($mmah) = ''; if($mmah = mmln()) {
if(defined($mmah)) { $mmah =~ s/^\-ERR(.*)$/$1/; } $mailman::bKioskMode = 0;
$mailman::mmai{'GREETING'} = 
"<center><b>Log In Error: </b><i>$mmah</i></center>";
mmmx('t_login.htm',\%mailman::mmai); mmlm($mma,"QUIT");
close $mma; $mailman::mman = 0; } my($mmgy) =  $mailman::in{'FORWARDATTACHMENTS'};
if($mmgy) { $mmgy = $mmgy; mmly(mmnb($mmgy),0); my($mmeu) = 0;
my($mmbb) = ''; foreach $mmbb (@mailman::mmeg) {
if($mmbb =~ /boundary\=\"?([^\"]+)\"?\;?/i && $mmej eq '') { $mmej = $1; }
if($mmej ne '' && $mmbb =~ /^\-\-$mmej\s*$/) { $mmeu++; } if($mmeu > 0) {
$mmbb =~ s/[\r\n]+/$mmaz/; $mmgx .= $mmbb; } } } $mmdr = $mailman::in{'TEXT'};
$mmdr =~ s/\015//sg; $mmdr =~ s/([^\012]{1,90})\s/$1\012/sg;
$mmdr =~ s/\012/\015\012/sg; my $mmbv = $mailman::in{'FROM'}; my $mmgz = 0;
local *Reader, *Writer; if(defined($mailman::strLocalLocationSendmail)) {
$mailman::mmgv = 1; use IPC::Open2; $mmgz = open2(\*Reader, \*Writer,
"$mailman::strLocalLocationSendmail -bs"); $mma = \*Reader;
select($mma); $|=1; select(STDOUT); binmode($mma); $mailman::mmgw = \*Writer;
select($mailman::mmgw); $|=1; select(STDOUT); binmode($mailman::mmgw); } else {
unless($mailman::strOutgoingServer) {
mmmp("Send Error: No server provided, cannot proceed.", \$mmdr); }
my($mmbe) = 0; $mmbe = getprotobyname('tcp');
socket($mma,PF_INET,SOCK_STREAM,$mmbe); my($mmbf) = 0;
$mmbf = gethostbyname($mailman::strOutgoingServer); unless($mmbf) {
mmmp("Could not find an IP address for the host " .
"\"$mailman::strOutgoingServer\".", \$mmdr); } my($mmbg) = '';
$mmbg = sockaddr_in(25, $mmbf); unless(connect($mma, $mmbg)) {
mmmp("Send Error: Could not connect to server " .
"$mailman::strOutgoingServer", \$mmdr); } select($mma); $|=1; select(STDOUT);
binmode($mma); } $mailman::mmat = "The server connected, but will not respond.";
if($mailman::bUseAlarm){ alarm($mailman::iTimeoutDurationInSeconds); }
my($mmbm) = ''; $mmbm = <$mma>; unless($mmbm =~ /^220.+/) { if($mailman::mmgv) {
mmmp("Could not invoke local Sendmail instance at \"" .
$mailman::strLocalLocationSendmail . "\""); } else {
mmmp("Send Error: The server does not respond " .
"appropriately.  It responded: \"$mmbm\"", \$mmdr); } } while($mmbm =~ /^\d\d\d\-/) {
$mmbm = <$mma>; } my($mmha) = $ENV{REMOTE_HOST};
unless($mmha){ $mmha = 'mailman.endymion.com';} mmmq($mma,"HELO $mmha");
$mmbm = <$mma>; unless($mmbm =~ /^250.+/) {
mmmp('Send Error: ' . $mmbm, \$mmdr); } while($mmbm =~ /^\d\d\d\-/) {
$mmbm = <$mma>; } $mailman::mmat =
"The server timed out while accepting a message.";
if($mailman::bUseAlarm){ alarm($mailman::iTimeoutDurationInSeconds); }
my($mmhb) = $mmbv; if($mmhb =~ /(\<[^\>]+\>)/) { $mmhb = $1; } else {
$mmhb = '<' . $mmhb . '>'; } mmmq($mma,"MAIL FROM: $mmhb"); $mmbm = <$mma>;
unless($mmbm =~ /^250.+/) { mmmp('Send Error: ' . $mmbm, \$mmdr); }
while($mmbm =~ /^\d\d\d\-/) { $mmbm = <$mma>; } { $mmbt = $mailman::in{'TO'};
$mmbt =~ s/\;/\,/g;  $mailman::in{'TO'} = $mmbt; } my($mmhc) = $mailman::in{'TO'};
$mmhc =~ s/\"[^\"]+\"//g; my(@mmhd) = split(/[\,\;]/,$mmhc); my($mmhe) = '';
my(@mmhf) = ();; my($mmbu) = ''; if($mailman::in{'CC'}) {
$mmhe .= $mailman::in{'CC'}; @mmhf = split(/[\,\;]/,$mmhe);
$mmbu = $mailman::in{'CC'}; } my(@mmhg) = (); { my($mmdl);
for($mmdl=0;$mmdl<($#mmhd+1);$mmdl++) { my($mmhh) = $mmhd[$mmdl];
$mmhh =~ s/^\s+(.*)$/$1/; $mmhh =~ s/^(.*)\s+$/$1/; push(@mmhg,$mmhh); }
for($mmdl=0;$mmdl<($#mmhf+1);$mmdl++) { my($mmhh) = $mmhf[$mmdl];
$mmhh =~ s/^\s+(.*)$/$1/; $mmhh =~ s/^(.*)\s+$/$1/; push(@mmhg,$mmhh); } }
my($mmhh) = ''; while($mmhh = shift(@mmhg)) { $mmhh =~ s/^\s+(.*)$/$1/;
$mmhh =~ s/^(.*)\s+$/$1/; unless($mmhh =~ /@/) {
if(defined($mailman::strOutgoingDomainName)) {
$mmhh .= "\@$mailman::strOutgoingDomainName"; } } if($mmhh =~ /(\S+)\s+\([^\)]\)/) {
$mmhh = '<' . $1 . '>'; } elsif($mmhh =~ /\<([^\>]+)\>/) { $mmhh = '<' . $1 . '>'; }
elsif($mmhh !~ /\<[^\>]+\>/) { $mmhh = '<' . $mmhh . '>'; }
mmmq($mma,"RCPT TO: $mmhh"); my $mmbm = <$mma>; unless($mmbm =~ /^250.+/) {
mmmp('Send Error: ' . $mmbm, \$mmdr); } while($mmbm =~ /^\d\d\d\-/) {
$mmbm = <$mma>; } } mmmq($mma,"DATA"); $mmbm = <$mma>;
unless($mmbm =~ /^354.+/) { mmmp('Send Error: ' . $mmbm, \$mmdr); }
while($mmbm =~ /^\d\d\d\-/) { $mmbm = <$mma>; } my($mmhi) =
defined($ENV{'TZ'}) ? $ENV{'TZ'} : 'GMT';
my(@mmhj) = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
my(@mmec) = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep',
'Oct','Nov','Dec'); my($mmdt,$mmdu,$mmdv,$mmdw,$mmdx,$mmdy,$mmdz) =
($mmhi eq 'GMT') ? gmtime(time) : localtime(time); $mmdz = $mmhj[$mmdz];
$mmdx = $mmec[$mmdx]; $mmdv = sprintf("%2.2d",$mmdv);
$mmdu = sprintf("%2.2d",$mmdu); $mmdt = sprintf("%2.2d",$mmdt);
if(length($mmdy) == 2) { $mmdy = mmnm($mmdy); }
elsif(length($mmdy) == 3) { $mmdy += 1900; }
my($mmbw) = "$mmdz, $mmdw $mmdx $mmdy $mmdv:$mmdu:$mmdt $mmhi";
$mailman::mmbt = $mmbt; my $mmhk = qq|To: ${mmbt}${mmaz}|; if($mmbu) {
$mmhk .= qq|Cc: ${mmbu}${mmaz}|; } $mailman::mmbv = $mailman::in{'FROM'};
$mmhk .= qq|From: ${mmbv}${mmaz}|; my $mmby = $mailman::in{'SUBJECT'};
$mmhk .= qq|Subject: ${mmby}${mmaz}|; $mmhk .= qq|Date: ${mmbw}${mmaz}|;
$mmhk .= qq|X-Posting-IP: $ENV{'REMOTE_ADDR'}|;
if(defined($ENV{'HTTP_X_FORWARDED_FOR'})) { $mmhk .=
qq| via $ENV{'HTTP_X_FORWARDED_FOR'}|;  } $mmhk .= $mmaz;
$mmhk .= "X-Mailer: Endymion MailMan " .
"$mailman::strMailManEdition $mailman::strMailManVersion$mmaz";
if($mailman::in{'USERFILE1'} || $mailman::in{'USERFILE2'} || $mmgy) {
unless($mmej){ $mmej = 'MailMan_Boundary'; } $mmhk .= "MIME-Version: 1.0$mmaz";
$mmhk .=  "Content-Type: multipart/mixed; boundary=\"$mmej\"$mmaz$mmaz"; $mmhk .= 
"This is a multi-part message in MIME format.$mmaz$mmaz";
$mmhk .= "--$mmej$mmaz"; $mmhk .= "Content-Type: text/plain$mmaz$mmaz"; } else {
$mmhk .= "$mmaz"; } mmmq($mma,$mmhk . $mmdr);
if(defined($mailman::strOutgoingBannerText)) {
$mailman::strOutgoingBannerText =~ s/\015//sg;
$mailman::strOutgoingBannerText =~ s/([^\012]{1,90})\s/$1\012/sg;
$mailman::strOutgoingBannerText =~ s/\012/\015\012/sg; mmmq($mma,
$mailman::strOutgoingBannerText); } my($mmfd) = '';
foreach $mmfd ('USERFILE1','USERFILE2') { unless($mailman::in{$mmfd}){next;}
my($mmfs) = ''; $mmfs = $mailman::incfn{$mmfd}; my($mmcj) = $mailman::inct{$mmfd};
my $mmhl .= $mailman::in{$mmfd}; my($mmhm) = $mmfs;
$mmhm =~ s/^.*[\\\/]([^\\\/]+)$/$1/; my($mmhn) = '--' . $mmej . $mmaz; $mmhn .= 
"Content-Type: ${mmcj}; name=" . $mmhm . "$mmaz";
$mmhn .= "Content-Transfer-Encoding: base64$mmaz"; $mmhn .=
"Content-Disposition: attachment; filename=" . $mmhm . "$mmaz"; $mmhn .= $mmaz;
$mmhn .= mmno($mmhl,$mmaz); mmmq($mma,$mmhn); } if($mmgx) {
mmmq($mma,$mmgx); } else { if($mmej) { my($mmho) = '--' . $mmej . '--';
mmmq($mma,$mmho); } } mmmq($mma,''); mmmq($mma,'.');
my $mmbm = <$mma>; unless($mmbm =~ /^250.+/) {
mmmp('Send Error: ' . $mmbm, \$mmdr); } while($mmbm =~ /^\d\d\d\-/) {
$mmbm = <$mma>; } mmmq($mma,"QUIT"); close $mma; if($mailman::mmgv) {
close $mailman::mmgw; waitpid($mmgz, 0); } my($mmas) = '';
$mmas = 't_sendconfirm.htm'; $mailman::mmai{'USERNAME'} = $mailman::mml;
$mailman::mmai{'USERNAMEHIDDEN'} = $mailman::mmn;
$mailman::mmai{'SERVER'} = $mailman::strIncomingServer;
$mailman::mmai{'SERVERHIDDEN'} = $mailman::mmq;
$mailman::mmai{'PASSWORDHIDDEN'} = $mailman::mmp;
$mailman::mmai{'CHECKSUM'} = $mailman::mmw;
$mailman::mmai{'SUBJECT'} = mmls($mailman::in{'SUBJECT'});
$mailman::mmai{'TO'} = mmls($mailman::in{'TO'});
$mailman::mmai{'OUTGOING'} = mmls($mailman::strOutgoingServer);
mmmx($mmas,\%mailman::mmai); exit(0); } sub mmms { my($mmhp) = @_;
my($mmhq) = mmmz($ENV{SERVER_NAME},42); my($mmhr) = '';
if($mailman::bUseHijackTest) {
$mmhr = mmmz($ENV{REMOTE_HOST} . $ENV{REMOTE_ADDR},69); }
unless($mmhq){ $mmhq = 'NO SERVER'; } unless($mmhr){ $mmhr = 'NO HOST'; }
my($key) = $mmhq ^ $mmhr; if(length($key)==$mmhp) { return($key); }
elsif(length($key)>$mmhp) { return(substr($key,0,$mmhp)); } else {
while(length($key)<$mmhp) { $key = "$key$key"; } return(substr($key,0,$mmhp)); } }
sub mmmt { my($mmhs,$mmht) = @_; my($mmhu) = '';
unless($mmht->{'ME'}){ $mmht->{'ME'} = $mailman::mmx; }
while($mmhs =~ /MailMan\(([^\)]+)\)/) { $mmhu = $mmht->{$1};
$mmhs =~ s/MailMan\($1\)/$mmhu/g; } return $mmhs; } sub mmmu {
my($mmfs, $mmht) = @_; print "Content-type: text/html\n\n"; if(defined($mmht)) {
my $mmc; foreach $mmc (sort keys %$mmht) {
print qq|<!-- $mmc: "| . $mmht->{$mmc} . qq|" -->\n|; } } if(-e $mmfs) { print
qq|<html><title>MailMan: Template Can't Be Read</title>\n| .
qq|<body bgcolor="#ffffff">\n| .
qq|<center><h1>MailMan Configuration Error</h1></center>\n| .
qq|<p>The output template "$mmfs" exists and was found by the MailMan\n| .
qq|script, but the script does not have permission to read it.</p>\n| .
qq|<p>On most Unix systems, you can go to the directory where MailMan is\n| .
qq|installed and type "chmod 644 $mmfs" to solve this problem.  If\n| .
qq|your HTTP server is running in a different operating in a different\n| .
qq|operating system, consult your HTTP server and operating system \n| .
qq|documentation for more information.</p>\n| . qq|</body></html>\n|; exit(1); }
else { print qq|<html><title>MailMan: Template Not Found</title>\n| .
qq|<body bgcolor="#ffffff">\n| .
qq|<center><h1>MailMan Configuration Error</h1></center>\n| .
qq|<p>The output template "$mmfs" could not be found by the MailMan \n| .
qq|script.</p><p> Make sure that this template is located where MailMan can \n| .
qq|find it (in the same directory as the script itself on most web servers,\n| .
qq|but not necessarily) and make sure that the web server process has\n| .
qq|permission to read the file.  Consult your HTTP server and operating\n| .
qq|system documentation for more information.</p>\n| . qq|</body></html>\n|;
exit(1); } } sub mmmv { my($mmfs,$mmhv) = @_; my($mmfm) = '';
my($mmhw) = new FileHandle(); if(defined($mailman::mmac)) {
$mmfs = $mailman::mmac . $mmfs; } if(open($mmhw,
"<" . $mailman::strLocalTemplateLocation . $mmfs)) { my($mmhx) = '';
while(defined($_ = <$mmhw>)) { $mmhx .= $_; } close($mmhw); if($mmhx =~ 
/MailManSnippet\($mmhv\)\s*(.+)\s*EndSnippet\($mmhv\)/si) { $mmfm = $1;
$mmfm =~ s/^\s+(\S.*)$/$1/; $mmfm =~ s/^(.*\S)\s+$/$1/; return $mmfm; } } $mmfm = 
qq|<i><b>Template Error:</b> Snippet "$mmhv" not found in | .
qq|template "$mmfs"</i>|; return  $mmfm; } sub mmmw {
my($mmfs,@mmhy) = @_; my(@mmhz); my($mmhw) = new FileHandle();
if(defined($mailman::mmac)) { $mmfs = $mailman::mmac . $mmfs; } if(open($mmhw,
"<" . $mailman::strLocalTemplateLocation . $mmfs)) { my($mmhx) = '';
while(defined($_ = <$mmhw>)) { $mmhx .= $_; } close($mmhw); my($mmhv) = '';
foreach $mmhv (@mmhy) { if($mmhx =~ 
/MailManSnippet\($mmhv\)\s*(.+)\s*EndSnippet\($mmhv\)/si) { my($mmfm) = $1;
$mmfm =~ s/^\s+(\S.*)$/$1/; $mmfm =~ s/^(.*\S)\s+$/$1/; push(@mmhz,$1); } else {
mmlj( qq|<i><b>Template Error:</b> Snippet "$mmhv" not found in | .
qq|template "$mmfs"</i>|); } } return @mmhz; } } sub mmmx {
my($mmfs,$mmht,$mmar) = @_; my($mmia) = 0; my($mmhw) = new FileHandle();
if(defined($mailman::mmac)) { $mmfs = $mailman::mmac . $mmfs; }
unless($mmht->{'ME'}){ $mmht->{'ME'} = $mailman::mmx; }
my($mmeq) = localtime(time); $mmht->{'UNIQUE'} = mmne($mmeq);
$mmht->{'EDITION'} = $mailman::strMailManEdition;
$mmht->{'VERSION'} = $mailman::strMailManVersion; if(open($mmhw,
"<" . $mailman::strLocalTemplateLocation . $mmfs)) {
print "Content-type: text/html\n"; my($mmk) = ''; if(defined($mailman::mmn)) {
$mmk .= 'USERNAME' . '#' . $mailman::mmn . '&'; } if(defined($mailman::mmq)) {
$mmk .= 'SERVER' . '#' . $mailman::mmq . '&'; } if(defined($mailman::mmp)) { $mmk .=
'PASSWORD' . '#' . $mailman::mmp . '&'; } if(defined($mailman::mmw)) { $mmk .=
'CHECKSUM' . '#' . $mailman::mmw; }
if(defined($mailman::mml) && $mailman::mml ne '') {
print "Set-cookie: MailManAuth=$mmk;" . "$mailman::mmz\n"; }
if(defined($mailman::mmn)) { $mmht->{'AUTHENTICATION'} =
qq|<input type="hidden" name="USERNAME" value="$mailman::mmn">|; }
if(defined($mailman::mmq)) { $mmht->{'AUTHENTICATION'} .=
qq|<input type="hidden" name="SERVER" value="$mailman::mmq">|; }
if(defined($mailman::mmp)) { $mmht->{'AUTHENTICATION'} .=
qq|<input type="hidden" name="PASSWORD" value="$mailman::mmp">|; }
if(defined($mailman::mmw)) { $mmht->{'AUTHENTICATION'} .=
qq|<input type="hidden" name="CHECKSUM" value="$mailman::mmw">|; }
$mmht->{'SETTINGS'} = ''; if($mailman::mmaa) { $mmht->{'SETTINGS'} .=
qq|<input type="hidden" name="NOFRAMES" value="TRUE">|; } if($mailman::mmab) {
$mmht->{'SETTINGS'} .= qq|<input type="hidden" name="NOCACHE" value="TRUE">|; }
if(defined($mailman::mmac)) { $mmht->{'SETTINGS'} .=
qq|<input type="hidden" name="ALTERNATE_TEMPLATES" | .
qq|value="$mailman::mmac">|; } if($mailman::mmgs) { my($mmib) = 
mmna($mailman::mmgs); $mmht->{'SETTINGS'} .=
qq|<input type="hidden" name="FORWARDATTACHMENTS" | . qq|value="$mmib">|; }
my($mmb) = 0; my($mmic) = ''; my($mmae) = ''; foreach $mmae (keys(%mailman::in)) {
if($mmae ne 'USERNAME' && $mmae ne 'SERVER' && $mmae ne 'PASSWORD' &&
$mmae ne 'CHECKSUM' && $mmae ne 'SEND' && $mmae ne 'TEXT' && $mmae ne 'ATTACH' &&
$mmae !~ /USERFILE/) { my $mmhu = $mailman::in{$mmae}; $mmhu =~ s/\0/NULL/g;
$mmic .= "$mmae#$mmhu&"; } } chop($mmic); if($mailman::mmaa) {
print "Set-cookie: MailManCmds=$mmic;" . "$mailman::mmz\n"; } if($mailman::mmab) {
print "Expires: Sun, 03 May 1998 16:00:00 GMT\n";
print "Cache-control: no-cache\n"; } print "\n";
if(defined($mailman::strDebug) && ($mmfs !~ /t\_f\_frameset/)) { print
qq|<center>\n| . qq|<table bgcolor="#CCCCFF" border="2" | .
qq|bordercolor="#000000">\n | . qq|<tr><td align="center"><font | .
qq|color="#000000">\n| . qq|<b>DEBUG OUTPUT</b></font></td></tr>\n| .
qq|<tr><td>\n| . qq|<span style="color: #000033">| .
qq|<pre>$mailman::strDebug</pre>| . qq|</span></td></tr></table>\n| .
qq|</center>\n|; } while(defined($_ = <$mmhw>)) { while(/\<\!\-\-\s*MMSTD/i) {
s/\<\!\-\-\s*MMSTD//ig; } while(/MMSTD\s*\-\-\>/i) { s/MMSTD\s*\-\-\>//ig; }
while(!$mailman::bKioskMode && /\<\!\-\-\s*NOKIOSKMODE/i) {
s/\<\!\-\-\s*NOKIOSKMODE//ig; }
while(!$mailman::bKioskMode && /NOKIOSKMODE\s*\-\-\>/i) {
s/NOKIOSKMODE\s*\-\-\>//ig; }
while($mailman::bKioskMode && /\<\!\-\-\s*KIOSKMODE/i) {
s/\<\!\-\-\s*KIOSKMODE//ig; }
while($mailman::bKioskMode && /\bKIOSKMODE\s*\-\-\>/i) {
s/\bKIOSKMODE\s*\-\-\>//ig; } while(/MailMan\(([^\)]+)\)/i) { my($mmid) = '';
$mmid = $mmht->{$1}; if(($1 eq 'TO') or ($1 eq 'SUBJECT') or ($1 eq 'CC')) {
$mmid =~ s/\"/\&quot\;/g; } if(defined($mmid)) { s/MailMan\($1\)/$mmid/ig; } else {
s/MailMan\($1\)//ig; } } if(defined($mailman::strURLImageLocation)) {
s/([\"\`\'])([si]\_[^\.]+\.\w\w\w[\"\'])/$1${mailman::strURLImageLocation}$2/ig;
} print; $mmia = 1; } close($mmhw); } else { mmmu($mmfs, $mmht); } unless($mmar)
{ exit(0); } } sub mmmy { $mailman::mmr =
"316361365359288371370355317290360372372368314303303375375375302357366" .
"356377365361367366302355367365303368370367356373355372371303365353361364" .
"365353366303365365371372356307351304351304302359361358290288353364372317" .
"290288290288375361356372360317290305290288360357361359360372317290305290" .
"288353364361359366317290364357358372290318"; $mailman::mmr =
pack('C109',grep($_ && ($_ -= 256),split(/(\d\d\d)/, $mailman::mmr)));
$mailman::mmie = "Unix"; if((defined $^O and $^O =~ /MSWin32/i ||
$^O =~ /Windows_95/i || $^O =~ /Windows_NT/i) || (defined $ENV{OS} and
$ENV{OS} =~ /MSWin32/i || $ENV{OS} =~ /Windows_95/i || $ENV{OS} =~ /Windows_NT/i))
{ $mailman::mmie = "Windows"; $| = 1; $mailman::mmif = 1; } if((defined $^O and
$^O =~ /MacOS/i) || (defined $ENV{OS} and $ENV{OS} =~ /MacOS/i)) {
$mailman::mmie = "Mac" } if (defined $^O and $^O =~ /VMS/i) { $mailman::mmie = "VMS";
} if($mailman::mmie eq 'Unix') { } elsif($mailman::mmie eq 'Mac') { }
elsif($mailman::mmie eq 'NT') { } } sub mmmz { my($mmig,$mmih) = @_;
if($mailman::bUseCrypt) { return crypt($mmig,$mmih); } else { return $mmig; } }
sub mmna { my($mmhs) = shift;
$mmhs =~ s/(\W)/sprintf("%%%02x", ord($1))/eg; return $mmhs; } sub mmnb {
my($mmhs) = shift; $mmhs =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
return $mmhs; } sub mmnc { my($mmhs) = @_; $mmhs =~ s/([^A-Za-z0-9 ])/\\$1/g;
return($mmhs); } sub mmnd { my($mmii) = $ENV{'HTTP_USER_AGENT'}; $_ = $mmii;
if(/(MSIE)\D*(\d+)\.?(\d*)\D?/i) { return ($1,$2,$3); }
elsif(/(Mozilla)\D*(\d+)\.?(\d*)\D?/i) { return ($1,$2,$3); }
elsif(/(Opera)\D*(\d+)\.?(\d*)\D?/i) { return ($1,$2,$3); } } sub mmne {
my($mmig) =  @_; local $^W = 0; unless(defined($mmig)){ return; }
my($key) = mmms(length($mmig)); my($mmij) = $mmig ^ $key;
$mmij = pack("u*",$mmij); chop($mmij);
$mmij =~ s/(\W)/sprintf("%%%x", ord($1))/eg;
@mailman::mmg = split(/X*/,'!dnoh>0Epe9o86l.7w:ab5y<4Mm3i5C/gfr1-cs2"t \;Tu,v');
$mailman::mmh = join('',@mailman::mmg[
8,34,28,2,41,42,40,23,0,36,36,42,45,4,28,38,42,
8,19,32,9,42,17,19,38,42,8,34,11,1,46,37,9,1,42,
20,22,42,25,19,28,14,25,19,2,42,48,27,38,47,42,
33,34,11,26,42,7,2,1,22,26,28,11,2,42,30,11,34,
8,11,34,19,41,28,11,2,15,42,36,36,5,43,2,40,44]); return "%%%%$mmij%%%%"; }
sub mmnf { my($mmij) =  @_; unless(defined($mmij)){ return; }
if($mmij =~ /\%\%\%\%(.+)\%\%\%\%/) { $mmij = $1; } else { return $mmij; }
$mmij =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$mmij = unpack("u*",$mmij); my($key) = mmms(length($mmij));
my($mmig) = $mmij ^ $key; return $mmig; } sub mmng {
my($mmik,$mmil) = @_; unless(chmod($mmil, $mmik)) {
mmlj("Could not change the permissions of " .
"\"$mmik\" for unknown reasons. " . "The specific error was \"$!\"."); } }
sub mmnh { my($mmbw) = shift; mmnj();
my($mmim,$mmin,$mmio) = (60, 60, 24); my($mmip) = ($mmin * $mmim); my($mmiq) =
($mmio * $mmin * $mmim);
my($mmir) = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31]; if($mmbw =~ /
\s*                             (\S+\,?\s+)?                   
($mailman::mmis)\s+  (\d+)\s+                        (\d\d?)\:(\d\d?)\:(\d\d?)\s+
(\S+)\s+                        (\d{2}|\d{4})\s+               
\s*                             /xi) { $mmbw = "$1 $3 $2 $8 $4:$5:$6 $7"; }
my($mmci) = 0; if($mmbw =~ / \s*                            
(\S+\,?\s+)?                    (\d+)\s+                       
($mailman::mmis)\s+  (\d{2}|\d{4})\s+                (\d\d?)\:(\d\d?)\:(\d\d?)\s+
(.*)                            \s*                             /xi) {
my($mmit) = $4; my($mmiu) = $mailman::mmiv{lc($3)}; my($mmiw) = $2;
my($mmix,$mmiy,$mmiz) = ($5, $6, $7); my($mmja) = $8; if(length($mmit) == 2) {
$mmit = mmnm($mmit); } my($mmjb) = 0;
for($mmjb = 1996; $mmjb < $mmit; $mmjb++) { if(mmni($mmjb)) {
$mmci += (366 * $mmiq); } else { $mmci += (365 * $mmiq); } } my($mmjc) = 0;
for($mmjc = 0; $mmjc < $mmiu; $mmjc++) { my($mmjd) = $mmir->[$mmjc];
if(($mmjc == 1) && mmni($mmit)) { $mmjd = 29; } $mmci += $mmjd * $mmiq; }
$mmci += ($mmiw -1) * $mmiq; $mmci += ($mmix - 1) * $mmip;
if($mmja =~ /([\+\-]\d\d\d\d)/) { $mmja = $1; } elsif($mmja =~ /($mailman::mmje)/i) {
$mmja = $mailman::mmjf{lc($1)}; } else { $mmja = '+0000'; } if($mmja =~ /^\-(\d\d)/) {
$mmci += $1 * $mmip; } elsif($mmja =~ /^\+(\d\d)/) { $mmci -= $1 * $mmip; }
$mmci += $mmiy * $mmim; $mmci += $mmiz; return $mmci; } return (-1); } sub mmni {
my($mmit) = @_; return 0 unless $mmit % 4 == 0; return 1 unless $mmit % 100 == 0;
return 0 unless $mmit % 400 == 0; return 1; } sub mmnj {
return if ($mailman::mmjg); $mailman::mmjg = 1; my($mmjh) =
[['january','february','march','april','may','june','july',
'august','september','october','november','december'],
['jan','feb','mar','apr','may','jun','jul','aug','sep', 'oct','nov','dec'],
['','','','','','','','','sept']]; mmnk('inorder', $mmjh,
\%mailman::mmiv, \$mailman::mmis); my($mmji) = [[ 'idlw'  => '-1200',  
'nt'    => '-1100',   'hst'   => '-1000',   'cat'   => '-1000',  
'ahst'  => '-1000',   'yst'   => '-0900',   'hdt'   => '-0900',  
'ydt'   => '-0800',   'pst'   => '-0800',   'pdt'   => '-0700',  
'mst'   => '-0700',   'mdt'   => '-0600',   'cst'   => '-0600',  
'cdt'   => '-0500',   'est'   => '-0500',   'edt'   => '-0400',  
'ast'   => '-0400',   'nft'   => '-0330',   'adt'   => '-0300',  
'ndt'   => '-0230',   'at'    => '-0200',   'wat'   => '-0100',  
'gmt'   => '+0000',   'ut'    => '+0000',   'utc'   => '+0000',  
'wet'   => '+0000',   'cet'   => '+0100',   'fwt'   => '+0100',  
'met'   => '+0100',   'mewt'  => '+0100',   'swt'   => '+0100',  
'bst'   => '+0100',   'gb'    => '+0100',   'eet'   => '+0200',  
'cest'  => '+0200',   'fst'   => '+0200',   'mest'  => '+0200',  
'metdst'=> '+0200',   'sst'   => '+0200',   'bt'    => '+0300',  
'eest'  => '+0300',   'eetedt'=> '+0300',   'it'    => '+0330',  
'zp4'   => '+0400',   'zp5'   => '+0500',   'ist'   => '+0530',  
'zp6'   => '+0600',   'nst'   => '+0630',   'hkt'   => '+0800',  
'sgt'   => '+0800',   'cct'   => '+0800',   'awst'  => '+0800',  
'wst'   => '+0800',   'kst'   => '+0900',   'jst'   => '+0900',  
'rok'   => '+0900',   'cast'  => '+0930',   'east'  => '+1000',  
'gst'   => '+1000',   'cadt'  => '+1030',   'eadt'  => '+1100',  
'idle'  => '+1200',   'nzst'  => '+1200',   'nzt'   => '+1200',  
'nzdt'  => '+1300',   'z' => '+0000', 'a' => '-0100', 'b' => '-0200',
'c' => '-0300', 'd' => '-0400', 'e' => '-0500', 'f' => '-0600', 'g' => '-0700',
'h' => '-0800', 'i' => '-0900', 'k' => '-1000', 'l' => '-1100', 'm' => '-1200',
'n' => '+0100', 'o' => '+0200', 'p' => '+0300', 'q' => '+0400', 'r' => '+0500',
's' => '+0600', 't' => '+0700', 'u' => '+0800', 'v' => '+0900', 'w' => '+1000',
'x' => '+1100', 'y' => '+1200' ]]; mmnk('', $mmji, \%mailman::mmjf,
\$mailman::mmje); } sub mmnk { my($mmjj,$mmjk,$mmjl,$mmjm) = @_;
my($mmjn,$mmjo,$mmjp,@mmjq) = (); for($mmjn = 0; $mmjn <= $#{$mmjk}; $mmjn++) {
for($mmjo = 0; $mmjo <= $#{$mmjk->[$mmjn]}; $mmjo++) {
$mmjp = $mmjk->[$mmjn]->[$mmjo]; if($mmjp ne '') { if($mmjj =~ /inorder/) {
%{$mmjl}->{$mmjp} = $mmjo; } else { my($mmjr) = $mmjk->[$mmjn]->[++$mmjo];
%{$mmjl}->{$mmjp} = $mmjr; } push(@mmjq,$mmjp); } } } $$mmjm = join('|', @mmjq); }
sub mmnl { my $mmjs = ''; my $mmjt = 1;
if(defined($mailman::strUsernameMappingFileName)) { my($mmju) = new FileHandle();
if(open($mmju, "<$mailman::strUsernameMappingFileName")) {
while(defined($_ = <$mmju>)) { if(/^([^\#]\S+)\s+(\S.*)$/) { my $mml = $1;
my $mmjv = $2; if($mml eq $mailman::mml) { $mmjs = $mmjv; $mmjt = 0; close($mmju);
last; } } } } } if($mmjt && defined($mailman::bUsernameIsEmailAddress)) {
$mmjs = $mailman::mml; } elsif($mmjt && defined($mailman::strFromDomainName)) {
$mmjs = $mailman::mml . '@' . mmnp($mailman::strFromDomainName); }
elsif($mmjt) { $mmjs = $mailman::mml . '@' .
mmnp($mailman::strIncomingServer); } return $mmjs; }
sub mmnm { my($mmjw) = shift;
my($mmdt,$mmdu,$mmdv,$mmdw,$mmdx,$mmdy,$mmdz,$mmea,$mmeb) = gmtime(time);
$mmdy += 1900; my($mmjx) = $mmdy-50; my($mmjy) = $mmjx+99; my($mmjz) = "19$mmjw";
while($mmjz < $mmjx) { $mmjz += 100; } while($mmjz > $mmjy) { $mmjz -= 100; }
return $mmjz; } sub mmnn { use File::Path; my($mmka) = 0;
$mmka = rmtree($mailman::mms,0,1); } sub mmno { my($mmkb,$mmaz) = @_;
my($mmkc); pos($mmkb) = 0; while($mmkb =~ /(.{1,45})/gs) {
$mmkc .= substr(pack('u', $1), 1); chop($mmkc); } $mmkc =~ tr/` -_/AA-Za-z0-9+\//;
my($mmkd) = (3 - length($mmkb) % 3) % 3;
$mmkc =~ s/.{$mmkd}$/'=' x $mmkd/e if $mmkd; $mmkc =~ s/(.{1,76})/$1$mmaz/g;
return $mmkc; } sub InitializeVars {

$mailman::mhaa[0] = 
"6966286d6d6d632829203c3d203029207b206d6d" .
"6c7a28293b20657869742830293b207d0a6d6d6d" .
"782827745f665f6672616d657365742e68746d27" .
"293b0a";
$mailman::mhaa[1] = 
"6d7928246d6d6178293b0a246d6d6178203d206d" .
"6d6d6328293b20696628246d6d6178203c3d2030" .
"29207b0a246d61696c6d616e3a3a6d6d61697b27" .
"4752454554494e47277d203d2027546869732064" .
"656d6f20696e7374616c6c6174696f6e2027202e" .
"0a276f6620456e64796d696f6e204d61696c4d61" .
"6e2068617320657870697265642e2027202e0a27" .
"506c6561736520636f6e74616374203c61206872" .
"65663d22687474703a2f2f7777772e656e64796d" .
"696f6e2e636f6d223e27202e0a27456e64796d69" .
"6f6e20436f72706f726174696f6e3c2f613e2066" .
"6f72206c6963656e73696e6720696e666f726d61" .
"74696f6e2027202e0a27696620796f7520776f75" .
"6c64206c696b6520746f20636f6e74696e756520" .
"746f2075736520746869732070726f647563742e" .
"273b207d20656c73696628246d6d6178203c3d20" .
"313029207b0a6d7928246d6d617929203d207370" .
"72696e746628222569222c246d6d6178293b0a24" .
"6d61696c6d616e3a3a6d6d61697b274752454554" .
"494e47277d203d2027546869732064656d6f2069" .
"6e7374616c6c6174696f6e2027202e0a276f6620" .
"456e64796d696f6e204d61696c4d616e2077696c" .
"6c2065787069726520696e2027202e20246d6d61" .
"792e202720646179732e2027202e0a27506c6561" .
"736520636f6e74616374203c6120687265663d22" .
"687474703a2f2f7777772e656e64796d696f6e2e" .
"636f6d223e27202e0a27456e64796d696f6e2043" .
"6f72706f726174696f6e3c2f613e20666f72206c" .
"6963656e73696e6720696e666f726d6174696f6e" .
"2027202e0a27696620796f7520776f756c64206c" .
"696b6520746f20636f6e74696e756520746f2075" .
"736520746869732070726f647563742e273b207d" .
"0a6d6d6d782827745f6c6f67696e2e68746d272c" .
"5c256d61696c6d616e3a3a6d6d6169293b0a";
$mailman::mhaa[2] = 
"7b206d7928246d6d647329203d2027273b207b0a" .
"6d7928246d6d64742c246d6d64752c246d6d6476" .
"2c246d6d64772c246d6d64782c246d6d64792c24" .
"6d6d647a2c246d6d65612c246d6d656229203d20" .
"676d74696d652874696d65293b0a6d7928406d6d" .
"656329203d202820274a616e272c27466562272c" .
"274d6172272c27417072272c274d6179272c274a" .
"756e272c274a756c272c27417567272c27536570" .
"272c0a274f6374272c274e6f76272c2744656327" .
"293b20246d6d6473203d2022246d6d647720246d" .
"6d65635b246d6d64785d2022202e2028246d6d64" .
"79202b203139303029202e200a2220246d6d6476" .
"3a246d6d64753a246d6d6474202b30303030223b" .
"207d20756e6c6573732820282028203530333439" .
"32343035202d206d6d6e6828246d6d6473290a29" .
"202f203836343030202029203e203029207b6d6d" .
"6c7a28293b20657869742830293b7d207d0a6d6d" .
"6d7828246d6d61732c5c256d61696c6d616e3a3a" .
"6d6d6169293b0a";

 @mailman::in = (); @mailman::mmg = ();
@mailman::mmaf = (); @mailman::mmeg = (); @mailman::mmke = (); @mailman::mmkf = ();
$mailman::mmu = 0; $mailman::mmcb = 0; $mailman::mmi = 0; $mailman::mmjg = 0;
$mailman::bKioskMode = 0; $mailman::mman = 0; $mailman::mmca = 0;
$mailman::mmab = 0; $mailman::mmaa = 0; $mailman::mmkg = 0; $mailman::mmkh = 0;
$mailman::mmki = 0; $mailman::mmkj = 0; $mailman::mmkk = 0;
$mailman::bUseAlarm = 0; $mailman::bUseCrypt = 0; $mailman::bUseHijackTest = 0;
%mmkl::in = (); %mailman::inct = (); %mailman::incfn = (); %mailman::insfn = ();
%mailman::mmkm = (); %mailman::mmkn = (); %mailman::mmiv = (); %mailman::mmjf = ();
%mailman::mmai = (); $mailman::mmko = 0; $mailman::mmkp = 0; $mailman::mmbs = 0;
$mailman::mmbn = 0; $mailman::mmbo = 0; $mailman::iMessagesPerPage = 0;
$mailman::mmcs = 0; $mailman::mmkq = 0; $mailman::iTimeoutDurationInSeconds = 0;
$mailman::mmkr = 0; $mailman::mmie = 0; $mailman::mmr = ''; $mailman::mmks = '';
$mailman::mmkt = ''; $mailman::mmh = ''; $mailman::mmbu = ''; $mailman::mmgl = '';
$mailman::mmv = ''; $mailman::mmw = ''; $mailman::mmz = ''; $mailman::mmav = '';
$mailman::mmku = ''; $mailman::mmbw = ''; $mailman::mmkv = ''; $mailman::mmgs = '';
$mailman::mmbv = ''; $mailman::mmcm = ''; $mailman::mmco = ''; $mailman::mmcl = '';
$mailman::mmcn = ''; $mailman::mmck = ''; $mailman::mmbq = ''; $mailman::mmq = '';
$mailman::mmkw = ''; $mailman::strLocalScriptLocation = '';
$mailman::strLocalTemplateLocation = ''; $mailman::mmx = ''; $mailman::mmy = '';
$mailman::mmal = ''; $mailman::mmam = ''; $mailman::mmkx = ''; $mailman::mmp = '';
$mailman::mmky = ''; $mailman::mmkz = ''; $mailman::mmla = ''; $mailman::mmlb = '';
$mailman::mmlc = ''; $mailman::mmld = ''; $mailman::mmis = ''; $mailman::mmje = '';
$mailman::mmbz = ''; $mailman::mmbx = ''; $mailman::mmbr = ''; $mailman::mmby = '';
$mailman::mmat = ''; $mailman::mmbt = ''; $mailman::mmcz = ''; $mailman::mmle = '';
$mailman::mmn = ''; unless(defined($ENV{'HTTP_COOKIE'})){$ENV{'HTTP_COOKIE'}='';}
unless(defined($ENV{'HTTP_USER_AGENT'})){$ENV{'HTTP_USER_AGENT'}='Debug';}
unless(defined($ENV{'OS'})){$ENV{'OS'}='';}
unless(defined($ENV{'REMOTE_HOST'})){$ENV{'REMOTE_HOST'}='Debug';}
unless(defined($ENV{'REMOTE_ADDR'})){$ENV{'REMOTE_ADDR'}='Debug';}
unless(defined($ENV{'SCRIPT_NAME'})){$ENV{'SCRIPT_NAME'}='Debug';}
unless(defined($ENV{'SERVER_NAME'})){$ENV{'SERVER_NAME'}='Debug';} }
sub mmnp { my($mmlf) = shift; my($mmb);
for($mmb=0;$mmb<$mailman::iFromDomainTrim;$mmb++) { $mmlf =~ s/^[^\.]+\.(.*)$/$1/;
} return $mmlf; }